#include <windows.h>
//#include <vcl\vcl.h>
#include <string.h>
#include <stdio.h>
#include <io.h>
#include <time.h>
#include <mbstring.h>
#include <tlhelp32.h>
#include "ese_general.h"
#include "ese_dokoitsu.h"
#include "ese_func.h"
#include "ese_acc_saori.h"
#include "ese_common.h"

//USEUNIT("ese_common.cpp");
//USEUNIT("ese_func.cpp");
//USEUNIT("ese_db.cpp");
//USEUNIT("ese_dokoitsu.cpp");
//USEUNIT("ese_acc_saori.cpp");
//---------------------------------------------------------------------------
//#define DEBUG 1

#define DEFAULT_LINE_BUF_SIZE 32768

unsigned long LINE_BUF_SIZE = DEFAULT_LINE_BUF_SIZE;

int GTalkLog;						//胍Oỏ
int GTalkLogLocal;					//胍Oỏۃ[N
int GResponseLog;					//X|XOỏ
int GEventLog;						//CxgOỏ
int GStringLog;						//擾Oỏ
int GRequestLog;					//SHIORI/3.0NGXgOỏ
char GStrNotWriteEvent[2048];		//eCxgʂ̃Oỏ
char GStrTalkBlockEvent[2048];		//eCxgʂ̒莞block̐ݒ
int GSaoriLog;						//vOCOỏ

int GTagSerErrOut;					//^OĨG[o̓XCb`
									//iڏoorOój

int GTalkAfterInterval;				//eg[N̍ŒԊub

char GStrDicCode[64];				//LqɎgpĂ镶R[h
int GStrDicCodeOld;					//݊ǂ

int GDBGFncAnalysis;				//fobOOoہi֐͕j
int GDBGIfAnalysis;					//fobOOoہiIF֐͕j

char GlobalPath[1024];				//loadɓnpX
char GProFile[1024];				//ݒt@CitpXj
char GUserDicFile[1024];			//[U[t@CitpXj

char* GAiDArea;						//ݎ̃GA擪|C^
void* GAiDArea_HGL;				//ݎ̃GAnh
StrDicPnt* GAiDic;					//ݎsf[^擪|C^
void* GAiDic_HGL;					//ݎsf[^GAnh
unsigned long GAiDicLine;			//ݑs
StrEntryList* GEntryList;			//ʏGge[uiChJ[h܂ށj
char* GEntryListString;				//ʏGg̊i[GA

unsigned long GNormalEntryNo;		//ʏGgiAԂU鎞̂ݎgpj
unsigned long GResponseEntryNo;		//getresponse(commu)Gg
unsigned long GEventEntryNo;		//getresponse(event)Gg
unsigned long GStringEntryNo;		//getstring(P)Gg
unsigned long GRequestEntryNo;		//getrequest(SHIORI/3.0NGXg)Gg


char* GPlAiDArea[PL_DIC_NUM];			//̃GA擪|C^ij
void* GPlAiDArea_HGL[PL_DIC_NUM];		//̃GAnhij
StrDicPnt* GPlAiDic[PL_DIC_NUM];		//sf[^擪|C^ij
void* GPlAiDic_HGL[PL_DIC_NUM];		//sf[^GAnhij
unsigned long GPlAiDicLine[PL_DIC_NUM];	//sij
unsigned long GPlResponseEntryNo[PL_DIC_NUM];	//getresponse(normal)Ggij
StrEntryList* GPlEntryList[PL_DIC_NUM];			//ʏGge[uiChJ[h܂ށjij
char* GPlEntryListString[PL_DIC_NUM];			//ʏGg̊i[GAij


int GStrMemory[1000];				//PꗚLGA
int GStrMemCnt;						//Pꗚ̗

StrName *GStrName;					//ŒGgLGA
int GStrNameNum;					//ŗLGg

char GGhostName[130];				//̃S[Xg
char GSendGhostName[130];			//b葼S[Xg
int  GSendAge;						//bpϐ
char GReference[8][1024];			//bԓpt@XGA

int GOtherGhostNum;					//ݓɑ݂Ă鑼̃S[Xgl
char* GOtherGhostName[GHOST_NUM];	//ݓɑ݂Ă鑼̃S[Xgꗗ

int RND_FLG;						//tO
int HWND_FLG;						//HWnd擾ׂ̈̃bZ[WotO

int GHWnd;							//DLLnhEEBhE

char GRndEntry[130];					//_g[NpGg
char GRndEntryOld[10][130];			//_g[NpGgobNAbv
char* GStack[PUSH_NUM];				//ߊi[GA

long GRandomTalkCount;				//_g[NJE^
long GRandomTalkCountMax;			//_g[NJE^l
long GNewsReadCount;				//j[Xǂ݃JE^
long GNewsReadCountMax;				//j[Xǂ݃JE^l

int  GHeadCode;						//wb_R[h

char GNeuron[130];					//`hOtŕ\Gg
char GNeuronM[130];					//
char GNeuronK[130];					//
char GNeuronD[130];					//
char GNeuronE[130];					//
char GSynapses[130];					//

int GPopAreaWrite;					//101Ԉȍ~POPGAt@Cɏoǂ

int GSelfEventNum;						//ƃCxgo^
StrSelfEvent GSelfEvent[SELF_EVENT_MAX];//ƃCxgf[^

char GStrSakuraDicBase[24];			//TNLŗLx[X
char GStrKeroDicBase[24];			//PLŗLx[X


/* ͔pGA */
typedef struct chkresponse {
	char* chkstr;
	char* chkpoint;
	int no;
	int stack_no;
	int comblock_no;
	int comword_no;
	int bhistory_point;
} StrChkResp;
StrChkResp GStrChkResp[100];

/* ͓emۃ[N */
char* GComBlock[PENTRY_COM_B_NUM];
char* GComWord[PENTRY_COM_W_NUM];


int free_paragraph(void);
int read_profile(void);
int set_default_block_event(void);
int read_pop_area(void);
int write_pop_area(void);
int read_dic(void);
void set_other_dic(int dic_no);
void change_other_dic(int dic_no);
int read_dic_sub(char*);
unsigned long read_dicfile(char*);
int get_dic_list1( char* listname, char* buf, char *list[], int max_size, int max_num );
int get_dic_list2( char* file_base, char* list_buf, char* list[] );
int get_dicfile_info( char* org, WIN32_FIND_DATA* aifile, int no );
int chk_esedicfile( char* filename );
int read_file( char** pnt, char* filename, unsigned long size );
unsigned long get_aidic_line( char* filename );
int check_entry( char* entry, char *entry_type, unsigned long *entry_no );
int get_entry_table( void );
int chk_entry_sort1( const void* list1, const void* list2 );
int chk_entry_sort2( const void* list1, const void* list2 );
int init_koyu_tag(void);
int end_koyu_tag(void);

int get_response( char* input_buf, char* output_buf );
int get_event_res( char* input_buf, char* output_buf );
int get_simple_string( char* input_buf, char* output_buf );
int check_response_entry( char* input_buf, unsigned long entry_no, char* type, int autotag_flg );
int get_pare_num( char* buf );
char* get_pare_point( char* buf, int no );
int chk_tag_in_block( char* buf, int no );
int check_response_entry_sub( char* input_buf, char* chk_buf, int min, int max, unsigned long* word_no, int pare_no, char* block_history[] );
int get_entry_tag_num( char* buf );
int set_comm_arg(char* input_buf);
void set_rand( void );
int get_fmo(char* ghost, char* kero, int* hwnd, char* path, int no);
int get_ghost_num(void);
int get_myname( void );
int get_hwnd_from_name( char* ghost );
int send_hwnd_to_allghost( void );
int send_eselocal_event( char* request );
int send_eselocal_event_sub( char* event_str );
int delete_self_event_data( int del_no );

BOOL GetFileNameFromHwnd(HWND hWnd, LPTSTR lpszFileName, DWORD nSize);

int chk_shiori20_request( char* buf );
int chk_shiori30_request( char* buf );
int request_get_notify( char* buf );
int request_get_notify30( char* buf );
int request_get_ver( char* buf );
int request_get_ver30( char* buf );
int request_get_ai_status( char* buf );
int get_learning_data( char* entry );
int request_get_ai_talk( char* buf );
int request_get_ai_talk30( char* buf );
int aitalk_comm( char* request, char* buf );
int request_get_ai_targetword( char* buf );
int request_get_response( char* buf );
int request_get_event( char* buf, int type );
int request_get_simple_string( char* buf );
int request_test( char* buf );
int request_get_hwnd( char* buf );
int request_translate( char* buf );
int request_translate30( char* buf );
int request_shiori30( char* buf, int type );
char* get_request_line_from_no( char* top_point, int line );
int refe_to_orgtag( char* buf );
int change_cntchr_to_ascstr( char* buf );
int make_target_header( char* output, char* sentence, int ret_cd );
int make_target_header_word( char* output, char* word, int ret_cd );
int make_target_header30( char* output, char* outbuf, int ret_cd );


#define REQ_NOTIFY					1
#define REQ_GETVER					2
#define REQ_AI_STATUS				3
#define REQ_AI_RANDOM				4
#define REQ_AI_COMM					5
#define REQ_AI_TARGETWORD			6
#define REQ_RESPONSE				7
#define REQ_WORD					8
#define REQ_MATCHWORD				9
#define REQ_RESPONSE_EVENT			10
#define REQ_TEST					11
#define REQ_RESPONSE_EVENT_SECOND	12
#define REQ_GET_HWND				13
#define REQ_RESPONSE_EVENT_CHOICE	14
#define REQ_SIMPLE_STRING			15
#define REQ_RESPONSE_EVENT_WORD		16
#define REQ_TRANSLATE				17
#define REQ_GETVER30				18
#define REQ_NOTIFY30				19
#define REQ_SHIORI30				20
#define REQ_SHIORI30_EVENT			21
#define REQ_SHIORI30_SECOND			22
#define REQ_SHIORI30_CHOICE			23
#define REQ_SHIORI30_RANDOM			24
#define REQ_SHIORI30_COMM			25
#define REQ_AI_COMM30				26
#define REQ_TRANSLATE30				27


// ckkEI֐
//---------------------------------------------------------------------------
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void* lpReserved)
{
	int loop_cnt;
	
	switch(reason){
		case DLL_PROCESS_ATTACH:
			/* ̈揉 */
			GAiDic = NULL;
			GAiDArea = NULL;
			for( loop_cnt = 0; loop_cnt < PL_DIC_NUM; loop_cnt++ ){
				GPlAiDic[loop_cnt] = NULL;
				GPlAiDArea[loop_cnt] = NULL;
			}
			
			/* ʏGge[u */
			GEntryList = NULL;
			GEntryListString = NULL;
			for( loop_cnt = 0; loop_cnt < PL_DIC_NUM; loop_cnt++ ){
				GPlEntryList[loop_cnt] = NULL;
				GPlEntryListString[loop_cnt] = NULL;
			}
			
			/* ߃GA */
			for( loop_cnt = 0; loop_cnt < PUSH_NUM; loop_cnt++ )GStack[loop_cnt] = NULL;
			
			break;

		case DLL_PROCESS_DETACH:
			/* ̈J */
			if( GAiDic != NULL ) free( GAiDic_HGL );
			if( GAiDArea != NULL ) free( GAiDArea_HGL );
			for( loop_cnt = 0; loop_cnt < PL_DIC_NUM; loop_cnt++ ){
				if( GPlAiDic[loop_cnt] != NULL ) free( GPlAiDic[loop_cnt] );
				if( GPlAiDArea[loop_cnt] != NULL ) free( GPlAiDArea[loop_cnt] );
			}
			
			/* ʏGge[uJ */
			for( loop_cnt = 0; loop_cnt < PL_DIC_NUM; loop_cnt++ ){
				if( GPlEntryList[loop_cnt] != NULL )free( GPlEntryList[loop_cnt] );
				if( GPlEntryListString[loop_cnt] != NULL )free( GPlEntryListString[loop_cnt] );
			}
			
			/* ߃GAJ */
			free_paragraph();
			
			break;
		case DLL_THREAD_ATTACH:
			break;

		case DLL_THREAD_DETACH:
			break;

		default:
			break;
	}
	return 1;
}

/************************************************************************/
/*				ickk[hɃR[j				*/
/************************************************************************/
extern "C" __declspec(dllexport) BOOL __cdecl load(HGLOBAL h, unsigned long len)
{

	int loop_cnt;
	
	/* ƃpX擾 */
	memcpy( GlobalPath,(char *)GlobalLock(h), len );
	GlobalPath[len] = '\0';
	if( GlobalPath[len-1] != '\\' )strcat( GlobalPath, "\\" );
	
	/* ݒt@C쐬 */
	strcpy( GProFile, GlobalPath );
	strcat( GProFile, "eseai.ini" );
	
	/* [U[t@C쐬 */
	strcpy( GUserDicFile, GlobalPath );
	strcat( GUserDicFile, "eseai_user.txt" );
	
	/* ƃpX󂯓nGAJ */
	GlobalFree(h);
	
	/* ̈JiȂj */
	if( GAiDic != NULL ) free( GAiDic_HGL );
	if( GAiDArea != NULL ) free( GAiDArea_HGL );
	for( loop_cnt = 0; loop_cnt < PL_DIC_NUM; loop_cnt++ ){
		if( GPlAiDic[loop_cnt] != NULL ) free( GPlAiDic[loop_cnt] );
		if( GPlAiDArea[loop_cnt] != NULL ) free( GPlAiDArea[loop_cnt] );
	}
	
	/* ʏGge[uJiȂj */
	GEntryList = NULL;
	GEntryListString = NULL;
	for( loop_cnt = 0; loop_cnt < PL_DIC_NUM; loop_cnt++ ){
		if( GPlEntryList[loop_cnt] != NULL )free( GPlEntryList[loop_cnt] );
		if( GPlEntryListString[loop_cnt] != NULL )free( GPlEntryListString[loop_cnt] );
		GPlEntryList[loop_cnt] = NULL;
		GPlEntryListString[loop_cnt] = NULL;
	}
	
	/* ߃GAJiȂj */
	free_paragraph();
	
	/* ݒt@Cǂݍ */
	read_profile();
	
	/* t@Cǂݍ */
	read_dic();
	
	/* _g[NpGg */
	strcpy( GRndEntry, "sr1**" );
	memset( GRndEntryOld, '\0', 6*10 );
	
	/* ̎擾 */
	srand( (unsigned)time( NULL ) );
	
	/* tO */
	RND_FLG = 0;
	
	/* HWnd擾ׂ̈̃bZ[WotOyHWnd */
	HWND_FLG = 0;
	GHWnd = -1;
	
	/* PLp[N */
	GStrMemCnt = 0;
	memset( GStrMemory, 0, sizeof(int)*1000 );
	
	/* ߃GA */
	for( loop_cnt = 0; loop_cnt < PUSH_NUM; loop_cnt++ )GStack[loop_cnt] = NULL;
	
	/* POPGAǂݍ */
	read_pop_area();
	
	/* SAORI.DLL[h */
	load_saori();
	
	/* S[XgGA */
	GOtherGhostNum = 0;
	for( loop_cnt = 0; loop_cnt < GHOST_NUM; loop_cnt++ )GOtherGhostName[loop_cnt] = NULL;
	
	/* ŗL^OGA */
	init_koyu_tag();
	
	/* ƃCxgpGA */
	GSelfEventNum = 0;
	for( loop_cnt = 0; loop_cnt < SELF_EVENT_MAX; loop_cnt++ ){
		GSelfEvent[loop_cnt].timer = -1;
		GSelfEvent[loop_cnt].send_string = NULL;
	}
	
	return(TRUE);
}

/************************************************************************/
/*				IickkA[hɃR[j			*/
/************************************************************************/
extern "C" __declspec(dllexport) BOOL __cdecl unload(void)
{
	
	int loop_cnt;
	
	/* POPGAo */
	write_pop_area();
	
	/* SAORI.DLLA[h */
	unload_saori();
	
	/* ̈J */
	for( loop_cnt = 0; loop_cnt < PL_DIC_NUM; loop_cnt++ ){
		if( GPlAiDic[loop_cnt] != NULL ) free( GPlAiDic[loop_cnt] );
		if( GPlAiDArea[loop_cnt] != NULL ) free( GPlAiDArea[loop_cnt] );
	}
	
	/* ʏGge[uJ */
	GEntryList = NULL;
	GEntryListString = NULL;
	for( loop_cnt = 0; loop_cnt < PL_DIC_NUM; loop_cnt++ ){
		if( GPlEntryList[loop_cnt] != NULL )free( GPlEntryList[loop_cnt] );
		if( GPlEntryListString[loop_cnt] != NULL )free( GPlEntryListString[loop_cnt] );
		GPlEntryList[loop_cnt] = NULL;
		GPlEntryListString[loop_cnt] = NULL;
	}
	
	/* ߃GAJ */
	free_paragraph();
	
	/* S[XgGAJ */
	for( loop_cnt = 0; loop_cnt < GHOST_NUM; loop_cnt++ ){
		if( GOtherGhostName[loop_cnt] != NULL ){
			free( GOtherGhostName[loop_cnt] );
		}
	}
	
	/* ŗL^OGAJ */
	end_koyu_tag();
	
	return(TRUE);
}

/************************************************************************/
/*				SHIORI/2.0NGXg								*/
/************************************************************************/
extern "C" __declspec(dllexport) HGLOBAL __cdecl request(HGLOBAL h, long* len)
{
	
	//static int reenter_flg = 0;
	int ret_cd;
	int loop_cnt;
	char wrk[1024];
	
	/* 񃊃GgX */
	//{̑őΉ̂ŉ
	/*if( reenter_flg == 1 ){
		strcpy( wrk, "SHIORI/2.0 204 No Content\r\n\r\n" );
		HGLOBAL new_h = GlobalAlloc( GMEM_FIXED, strlen(wrk) );
		memcpy( (char *)GlobalLock(new_h), wrk, strlen(wrk) );
		*len = strlen(wrk);
		return(new_h);
	}*/
	
	/* NɑSS[Xg"HWND"bZ[Wt */
	/* itO͎MɗĂ邪AG[΍lďTOj */
	if( HWND_FLG < 50 ){
		/* HWNDbZ[Włɗ̂ŖHWNDbZ[Wt */
		long meslen = *len;
		if( meslen > 127 )meslen = 127;
		memcpy( wrk, (char *)GlobalLock(h), meslen );
		wrk[meslen] = '\0';
		if( strstr( wrk, "EseGetHWnd" ) == NULL ){
			send_hwnd_to_allghost();
		}
	}
	
	//reenter_flg = 1;
	
	/* [NGA擾 */
	LINE_BUF_SIZE = *len + 1;
	if ( LINE_BUF_SIZE < DEFAULT_LINE_BUF_SIZE ) {
		LINE_BUF_SIZE = DEFAULT_LINE_BUF_SIZE;
	}

	char* moto_wrk = (char*)malloc(LINE_BUF_SIZE);
	if( moto_wrk == NULL ){
		strcpy( wrk, "SHIORI/2.0 400 Bad Request\r\n\r\n" );
		HGLOBAL new_h = GlobalAlloc( GMEM_FIXED, strlen(wrk) );
		memcpy( (char *)GlobalLock(new_h), wrk, strlen(wrk) );
		*len = strlen(wrk);
		//reenter_flg = 0;
		return(new_h);
	}
	
	long copyLen = *len;

	memcpy( moto_wrk, (char *)GlobalLock(h), copyLen );
	*( moto_wrk + copyLen ) = '\0';
	GlobalFree(h);

	log_write_user( "********************** start ******************", "ese_fncanl.log", GDBGFncAnalysis );
	log_write_user( moto_wrk, "ese_fncanl.log", GDBGFncAnalysis );
	/* ͂ĕ */
	int type = chk_shiori30_request(moto_wrk);
	if( type == -1 )type = chk_shiori20_request(moto_wrk);
	
	switch( type ){
		case REQ_RESPONSE_EVENT_SECOND:
			if( strlen(moto_wrk) > 127 ){
				memcpy( wrk, moto_wrk, 127 );
				wrk[127] = '\0';
			}
			else strcpy( wrk, moto_wrk );
		case REQ_AI_RANDOM:
		case REQ_RESPONSE_EVENT_CHOICE:
		case REQ_RESPONSE_EVENT_WORD:
		case REQ_RESPONSE_EVENT:
			ret_cd = request_get_event( moto_wrk, type );
			break;
		case REQ_NOTIFY:
			request_get_notify( moto_wrk );
			break;
		case REQ_GETVER:
			request_get_ver( moto_wrk );
			break;
		case REQ_AI_STATUS:
			request_get_ai_status( moto_wrk );
			break;
		case REQ_AI_COMM:
			request_get_ai_talk( moto_wrk );
			break;
		case REQ_RESPONSE:
			request_get_response( moto_wrk );
			break;
		case REQ_SIMPLE_STRING:
			request_get_simple_string( moto_wrk );
			break;
		case REQ_TEST:
			request_test( moto_wrk );
			break;
		case REQ_GET_HWND:
			request_get_hwnd( moto_wrk );
			break;
		case REQ_TRANSLATE:
			request_translate( moto_wrk );
			break;
		case REQ_GETVER30:
			request_get_ver30( moto_wrk );
			break;
		case REQ_NOTIFY30:
			request_get_notify30( moto_wrk );
			break;
		case REQ_SHIORI30_SECOND:
		case REQ_SHIORI30_CHOICE:
		case REQ_SHIORI30_RANDOM:
		case REQ_SHIORI30_COMM:
		case REQ_SHIORI30_EVENT:
		case REQ_SHIORI30:
			ret_cd = request_shiori30( moto_wrk, type );
			break;
		case REQ_AI_COMM30:
			request_get_ai_talk30( moto_wrk );
			break;
		case REQ_TRANSLATE30:
			request_translate30( moto_wrk );
			break;
		default:
			/* G[ */
			log_write_user( moto_wrk, "ese_bad_rqst.log", 1 );
			strcpy( moto_wrk, "SHIORI/2.0 400 Bad Request\r\n\r\n" );
			break;
	}
	
	HGLOBAL new_h = GlobalAlloc( GMEM_FIXED, strlen(moto_wrk) );
	memcpy( (char *)GlobalLock(new_h), moto_wrk, strlen(moto_wrk) );
	*len = strlen(moto_wrk);
	free(moto_wrk);
	//reenter_flg = 0;
	
	/* ƃCxg̒ősׂCxg͍`FbNĎs */
	for( loop_cnt = 0; loop_cnt < GSelfEventNum; loop_cnt++ ){
		if( GSelfEvent[loop_cnt].timer == 0 ){
			/* f[^Rs[č폜 */
			strcpy( wrk, GSelfEvent[loop_cnt].send_string );
			delete_self_event_data( loop_cnt );
			
			/* f[^M */
			COPYDATASTRUCT cds;
			cds.dwData = 9801;
			cds.cbData = strlen( wrk );
			cds.lpData = wrk;
			SendMessage( (HWND)GHWnd, WM_COPYDATA, NULL, (LPARAM) &cds );
			
		}
	}
	
	/* bCxg̏ꍇ͊e펩͔sCxgsȂ */
	/* iubNȂĂꍇ̂݁j           */
	if( ( type == REQ_RESPONSE_EVENT_SECOND || type == REQ_SHIORI30_SECOND ) && 
		 ret_cd != 2 )send_eselocal_event(wrk);
	
	log_write_user( (char *)GlobalLock(new_h), "ese_fncanl.log", GDBGFncAnalysis );
	log_write_user( "*********************** end *******************", "ese_fncanl.log", GDBGFncAnalysis );
	
	/* ̃S[XgEP擾 */
	get_myname();
	
	return(new_h);
	
	
}


/************************************************************************/
/*				߃GAJ										*/
/************************************************************************/
int free_paragraph(void)
{

	int loop_cnt;
	for( loop_cnt = 0; loop_cnt < PUSH_NUM; loop_cnt++ ){
		if( GStack[loop_cnt] != NULL ){
			free( GStack[loop_cnt] );
			GStack[loop_cnt] = NULL;
		}
	}
	return(0);
}


/************************************************************************/
/*				ݒt@Cǂݍݏ								*/
/************************************************************************/
int read_profile(void)
{
	
	/* px擾 */
	GRandomTalkCount = GRandomTalkCountMax = GetPrivateProfileInt( "ESEAI", "RANDOM_TALK_INTERVAL", 70, GProFile );
	GNewsReadCount = GNewsReadCountMax = GetPrivateProfileInt( "ESEAI", "NEWS_READ_INTERVAL", 240, GProFile );
	
	/* wCxg̍ŒԊu擾 */
	GTalkAfterInterval = GetPrivateProfileInt( "ESEAI", "TALK_BLOCK_INTERVAL", 5, GProFile );
	
	/* Cxgʃg[NubNېݒ擾 */
	if( GetPrivateProfileString( "ESEAI", "TALK_BLOCK_EVENT", "", GStrTalkBlockEvent, 2040, GProFile ) == 0 ){
		GStrTalkBlockEvent[0] = '\0';
	}
	set_default_block_event();
	
	/* LqɎgpĂ镶R[hʁiȗĂꍇShift_JISɎwj*/
	GetPrivateProfileString( "ESEAI", "DIC_CHAR_SET", "", GStrDicCode, 60, GProFile );
	if( GStrDicCode[0] == '\0' ){
		strcpy( GStrDicCode, "Shift_JIS" );
		GStrDicCodeOld = DIC_TYPE_1xx;		//݊`iCxg̓tShift-JIS\Lj
	}
	else GStrDicCodeOld = DIC_TYPE_2xx;		//V`iCxg̓tp\Lj
	
	/* eOL^̗L擾 */
	GResponseLog = GetPrivateProfileInt( "ESEAI", "RESPONSE_LOG", 0, GProFile );
	GTalkLog = GetPrivateProfileInt( "ESEAI", "COM_TALK_LOG", 0, GProFile );
	GEventLog = GetPrivateProfileInt( "ESEAI", "EVENT_LOG", 0, GProFile );
	GStringLog = GetPrivateProfileInt( "ESEAI", "STRING_LOG", 0, GProFile );
	GRequestLog = GetPrivateProfileInt( "ESEAI", "REQUEST_LOG", 0, GProFile );
	GSaoriLog = GetPrivateProfileInt( "ESEAI", "SAORI_LOG", 0, GProFile );
	
	/* ^OĨG[o͐w擾 */
	char wrk[130];
	if( GetPrivateProfileString( "ESEAI", "TAGSEL_ERROR_OUT", "DIRECT", wrk, 120, GProFile ) == 0 ){
		strcpy( wrk, "DIRECT" );
	}
	GTagSerErrOut = 0;
	if( memlcmp( wrk, "LOG" ) == 0 )GTagSerErrOut = 1;
	if( memlcmp( wrk, "NON" ) == 0 )GTagSerErrOut = 2;
	
	/* Lʎǂݍ */
	GetPrivateProfileString( "ESEAI", "SAKURA_DIC", "", GStrSakuraDicBase, 20, GProFile );
	GetPrivateProfileString( "ESEAI", "KERO_DIC", "", GStrKeroDicBase, 20, GProFile );
	
	/* CxgÕCxgʃOo۔ݒ擾 */
	if( GetPrivateProfileString( "ESEAI", "NOT_WRITE_EVENT", "", GStrNotWriteEvent, 2040, GProFile ) == 0 ){
		GStrNotWriteEvent[0] = '\0';
	}
	
	/* fobOOL^̗L擾 */
	GDBGFncAnalysis = GetPrivateProfileInt( "ESEAI_DEBUG", "FUNC_ANALYSIS", 0, GProFile );
	GDBGIfAnalysis = GetPrivateProfileInt( "ESEAI_DEBUG", "IF_ANALYSIS", 0, GProFile );
	
	/* POPGA101Ԉȍ~oǂ */
	GPopAreaWrite = GetPrivateProfileInt( "ESEAI", "POP_AREA_WRITE", 0, GProFile );
	
	/* `hOt\̈ */
	if( GetPrivateProfileString( "ESEAI_GRAPH", "Neuron", "", GNeuron, 128, GProFile ) == 0 ){
		GNeuron[0] = '\0';
	}
	if( GetPrivateProfileString( "ESEAI_GRAPH", "NeuronM", "", GNeuronM, 128, GProFile ) == 0 ){
		GNeuronM[0] = '\0';
	}
	if( GetPrivateProfileString( "ESEAI_GRAPH", "NeuronK", "", GNeuronK, 128, GProFile ) == 0 ){
		GNeuronK[0] = '\0';
	}
	if( GetPrivateProfileString( "ESEAI_GRAPH", "NeuronD", "", GNeuronD, 128, GProFile ) == 0 ){
		GNeuronD[0] = '\0';
	}
	if( GetPrivateProfileString( "ESEAI_GRAPH", "NeuronE", "", GNeuronE, 128, GProFile ) == 0 ){
		GNeuronE[0] = '\0';
	}
	if( GetPrivateProfileString( "ESEAI_GRAPH", "Synapses", "", GSynapses, 128, GProFile ) == 0 ){
		GSynapses[0] = '\0';
	}
	
	return(0);
}


/************************************************************************/
/*				ftHgŃubNȃCxgǉ			*/
/************************************************************************/
int set_default_block_event(void)
{

	
	char* p_wrk;
	char* nonblock_event[] = {  "OnSecond",
								"OnMinute" };
	int loop_cnt;
	int nonblock_event_num = 2;
	
	for( loop_cnt = 0; loop_cnt < nonblock_event_num; loop_cnt++ ){
		p_wrk = strstr( GStrTalkBlockEvent, nonblock_event[loop_cnt] );
		if( p_wrk == NULL ){
			strcat( GStrTalkBlockEvent, "," );
			strcat( GStrTalkBlockEvent, nonblock_event[loop_cnt] );
		}
	}
	
	return(0);
	

}


/************************************************************************/
/*				POPGAǂݍݏ									*/
/************************************************************************/
int read_pop_area(void)
{
	
	FILE* fp;
	char pop_file[1024];
	char wrk[4096];
	char* p_wrk;
	
	/* oȂݒȂǂݍ݂Ȃ */
	if( GPopAreaWrite == 0 )return(0);
	
	/* POPݒt@C쐬 */
	strcpy( pop_file, GlobalPath );
	strcat( pop_file, "ese_pop.dat" );
	
	/* t@CI[vit@C΂̂܂܏Ij */
	fp = fopen( pop_file, "rt" );
	if( fp == NULL )return(0);
	
	/* Psǂݍ */
	int loop_cnt;
	for( loop_cnt = PUSH_WRITE_START; loop_cnt < PUSH_NUM; loop_cnt++ ){
		/* Psǂݍ */
		if( fgets( wrk, 4096, fp ) == NULL )break;
		
		/* sR[h */
		p_wrk = strchr( wrk, '\r' );
		if( p_wrk != NULL )*p_wrk = '\0';
		p_wrk = strchr( wrk, '\n' );
		if( p_wrk != NULL )*p_wrk = '\0';
		
		/* 񒷂Ȍꍇ̓mۂȂ */
		if( wrk[0] == '\0' ){
			continue;
		}
		
		/* mۂď */
		free_target_paragraph( loop_cnt );
		if( ( GStack[loop_cnt] = (char*)malloc( strlen(wrk)+1 )) != NULL ){
			/* eRs[ */
			strcpy( GStack[loop_cnt], wrk );
		}
		else{
			GStack[loop_cnt] = NULL;
		}
		
	}
	
	/* t@CZꍇ͑ȂPUSHGANULLɂ */
	for( ; loop_cnt < PUSH_NUM; loop_cnt++ )GStack[loop_cnt] = NULL;
	
	/* t@CN[Y */
	fclose(fp);
	
	return(0);
	
}


/************************************************************************/
/*				POPGAo									*/
/************************************************************************/
int write_pop_area(void)
{
	
	FILE* fp;
	char pop_file[1024];
	
	/* oȂݒȂ牽Ȃ */
	if( GPopAreaWrite == 0 )return(0);
	
	/* POPݒt@C쐬 */
	strcpy( pop_file, GlobalPath );
	strcat( pop_file, "ese_pop.dat" );
	
	/* t@CI[v */
	fp = fopen( pop_file, "wt" );
	if( fp == NULL )return(0);
	
	/* Pso */
	int loop_cnt;
	for( loop_cnt = PUSH_WRITE_START; loop_cnt < PUSH_NUM; loop_cnt++ ){
		
		/* Pso */
		if( GStack[loop_cnt] != NULL )fprintf( fp, "%s\n", GStack[loop_cnt] );
		else						  fprintf( fp, "\n" );
		
	}
	
	/* t@CN[Y */
	fclose(fp);
	
	return(0);
	
}


/************************************************************************/
/*				ese-shiorit@Cǂݍݏ						*/
/************************************************************************/
int read_dic(void)
{
	
	/* Tuǂݍ */
	if( GStrSakuraDicBase[0] != '\0' ){
		read_dic_sub( GStrSakuraDicBase );
		set_other_dic(CHAR_SAKURA);
	}
	if( GStrKeroDicBase[0] != '\0' ){
		read_dic_sub( GStrKeroDicBase );
		set_other_dic(CHAR_KERO);
	}
	
	/* ftHgǂݍ */
	read_dic_sub("eseai");
	set_other_dic(0);
	
	return(0);
	

}

/************************************************************************/
/*				ǂݍ񂾎eLƂăZbg				*/
/************************************************************************/
void set_other_dic(int dic_no)
{
	GPlAiDic[dic_no]			= GAiDic;
	GPlAiDArea[dic_no]			= GAiDArea;
	GPlAiDArea_HGL[dic_no]		= GAiDArea_HGL;
	GPlAiDic_HGL[dic_no]		= GAiDic_HGL;
	GPlAiDicLine[dic_no]		= GAiDicLine;
	GPlResponseEntryNo[dic_no]	= GResponseEntryNo;
	GPlEntryList[dic_no]		= GEntryList;
	GPlEntryListString[dic_no]	= GEntryListString;
}


/************************************************************************/
/*				eL̐؂芷									*/
/************************************************************************/
void change_other_dic(int dic_no)
{
	GAiDic			 = GPlAiDic[dic_no];
	GAiDArea		 = GPlAiDArea[dic_no];
	GAiDArea_HGL	 = GPlAiDArea_HGL[dic_no];
	GAiDic_HGL		 = GPlAiDic_HGL[dic_no];
	GAiDicLine		 = GPlAiDicLine[dic_no];
	GResponseEntryNo = GPlResponseEntryNo[dic_no];
	GEntryList		 = GPlEntryList[dic_no];
	GEntryListString = GPlEntryListString[dic_no];
}


/************************************************************************/
/*				ese-shiorit@CǂݍݏiTuj				*/
/************************************************************************/
int read_dic_sub( char* file_base )
{

	unsigned long ai_dic_size;
	char* p_wrk;
	
	/* t@Cǂݍ݁it@Cǂށj */
	ai_dic_size = read_dicfile( file_base );
	if( ai_dic_size == 0 )return(1);

	/* sɉė̈擾 */
	GAiDic_HGL = malloc( sizeof(StrDicPnt)*GAiDicLine );
	if( GAiDic_HGL == NULL ){
		return(1);
	}
	else{
		GAiDic = (StrDicPnt*)GAiDic_HGL;
	}
	
	/* f[^̉sEdneR[h */
	unsigned long loop_cnt;
	for( loop_cnt = 0; loop_cnt < ai_dic_size; loop_cnt++ ){
		if( *(GAiDArea+loop_cnt) == 0x0d )*(GAiDArea+loop_cnt) = '\0';
		if( *(GAiDArea+loop_cnt) == 0x0a )*(GAiDArea+loop_cnt) = '\0';
		if( *(GAiDArea+loop_cnt) == 0x1a )*(GAiDArea+loop_cnt) = '\0';
	}
	
	/* Psׂ */
	char* p_ai_dic_area = GAiDArea;
	StrDicPnt* p_ai_dic = GAiDic;
	int line_num;
	char now_entry_type = '\0';
	unsigned long now_entry_no = 0L;
	unsigned long now_ratio=0;
	for(; (unsigned long)(p_ai_dic_area-GAiDArea) < ai_dic_size;){
		
		/* PC̒擾 */
		line_num = strlen( p_ai_dic_area );
		
		/* Rgsǂf */
		if( *p_ai_dic_area == '\0' ||
			*p_ai_dic_area == '/' && *(p_ai_dic_area+1) == '/' ){
			p_ai_dic_area += line_num+1;
			while( *p_ai_dic_area == '\0' && (unsigned long)(p_ai_dic_area-GAiDArea) < ai_dic_size )p_ai_dic_area++;
			continue;
		}
		
		/* si擪sȊOj */
		if( p_ai_dic_area > GAiDArea + 2 ){
			if( *p_ai_dic_area == 0x09 ||
				memlcmp( p_ai_dic_area, "$ELSE" ) == 0 ||
				memlcmp( p_ai_dic_area, "$ENDIF" ) == 0 ){
				
				/* Yꍇ͑Os̉s^uR[hɒu */
				*(p_ai_dic_area - 1) = 0x09;
				*(p_ai_dic_area - 2) = 0x09;
				
				p_ai_dic_area += line_num+1;
				while( *p_ai_dic_area == '\0' && (unsigned long)(p_ai_dic_area-GAiDArea) < ai_dic_size )p_ai_dic_area++;
				continue;
			}
		}
		
		/* Ggǂ`FbNiGgȂ炻̓e */
		if( *p_ai_dic_area == '#' ){
			/* Gg̓e擾 */
			check_entry( p_ai_dic_area, &now_entry_type, &now_entry_no );
			
			/* Ggs̃AhX擾 */
			p_ai_dic->string = p_ai_dic_area;
			p_ai_dic->entry_type = ' ';
			p_ai_dic->entry_no = 0;
			p_ai_dic->ratio = 0;
			p_ai_dic->tag_sel_style = 0;	//^OI̓_
			p_ai_dic->tag_sel_flg = 0;		//GgsɃtO͕KvȂ
			
			/* ̍s */
			p_ai_dic++;
			p_ai_dic_area += line_num+1;
			while( *p_ai_dic_area == '\0' && (unsigned long)(p_ai_dic_area-GAiDArea) < ai_dic_size )p_ai_dic_area++;
			continue;
		}

		/* f[^sȂ̂ňȉ̓f[^s̓e擾 */
		/* o䗦̎擾 */
		if( sscanf( p_ai_dic_area, "%ld,", &now_ratio ) == 1 &&
			( p_wrk = strchr(p_ai_dic_area,',') ) != NULL ){
			/* LqĂ̂ł̋Lq΂ĕAhXZbg */
			p_ai_dic->string = p_wrk+1;
		}
		else{
			/* ȗĂ̂ŃftHglZbg */
			now_ratio = 1;
			/* AhXZbg */
			p_ai_dic->string = p_ai_dic_area;
		}
		
		/* AhXAʓL */
		p_ai_dic->entry_type = now_entry_type;
		p_ai_dic->entry_no = now_entry_no;
		p_ai_dic->ratio = now_ratio;
		p_ai_dic->tag_sel_style = 0;		//f[^sɃ^OI͕KvȂ
		p_ai_dic->tag_sel_flg = TAGSEL_OK;	//tÓuI\v
		
		p_ai_dic_area += line_num+1;
		while( *p_ai_dic_area == '\0' && (unsigned long)(p_ai_dic_area-GAiDArea) < ai_dic_size )p_ai_dic_area++;
		
		p_ai_dic++;
		
	}
	
	/* Gg擾̏ */
	get_entry_table();
	
	return(0);

}


/************************************************************************/
/*				t@Cǂݍ݁it@CΉj				*/
/************************************************************************/
unsigned long read_dicfile( char* file_base )
{

	WIN32_FIND_DATA aifile;
	WIN32_FIND_DATA userfile;
	char ai_dic_name[1024];
	char ai_dic_name_wrk[4096];
	char* ai_dic_name_list[512];
	unsigned long ai_dic_size;
	int loop_cnt;
	int ai_dic_num;
	
	GAiDArea = NULL;
	GAiDic = NULL;
	GAiDicLine = 0;
	GNormalEntryNo = GResponseEntryNo = GEventEntryNo = GStringEntryNo = GRequestEntryNo = 0;
	
	/* `hXgt@C擾 */
	ai_dic_name_list[0] = NULL;
	strcpy( ai_dic_name, file_base );
	strcat( ai_dic_name, DIC_LIST_FILE );
	get_dic_list1( ai_dic_name, ai_dic_name_wrk, &ai_dic_name_list[0], 4096, 512 );
	get_dic_list2( file_base, ai_dic_name_wrk, &ai_dic_name_list[0] );
	
	/* `h̃t@C擾 */
	for( loop_cnt = 0; ai_dic_name_list[loop_cnt] != NULL; loop_cnt++ );
	ai_dic_num = loop_cnt;
	
	/* e`ht@C̃TCY擾Av */
	ai_dic_size = 0;
	for( loop_cnt = 0; loop_cnt < ai_dic_num; loop_cnt++ ){
		strcpy( ai_dic_name, GlobalPath );
		strcat( ai_dic_name, ai_dic_name_list[loop_cnt] );
		get_dicfile_info( ai_dic_name, &aifile, 0 );
		ai_dic_size += aifile.nFileSizeLow+2L;
	}
	
	/* `ḧm */
	GAiDArea_HGL = malloc( ai_dic_size+16L );
	if( GAiDArea_HGL == NULL ){
		return(0);
	}
	else{
		GAiDArea = (char *)GAiDArea_HGL;
	}
	
	/* e`hɓǂݍ݁Asv */
	char* read_pnt = GAiDArea;
	int user_flg = 0;
	GAiDicLine = 0;
	for( loop_cnt = 0; loop_cnt < ai_dic_num; loop_cnt++ ){
		
		/* [U[͍Ōɉ */
		if( strcmp( ai_dic_name_list[loop_cnt], "eseai_user.txt" ) == 0 ){
			strcpy( ai_dic_name, GlobalPath );
			strcat( ai_dic_name, ai_dic_name_list[loop_cnt] );
			get_dicfile_info( ai_dic_name, &userfile, 0 );
			user_flg = 1;
			continue;
		}
		
		/* 擾 */
		strcpy( ai_dic_name, GlobalPath );
		strcat( ai_dic_name, ai_dic_name_list[loop_cnt] );
		get_dicfile_info( ai_dic_name, &aifile, 0 );
		
		/* ǂݍ */
		if( read_file( &read_pnt, ai_dic_name, aifile.nFileSizeLow ) != 0 ){
			free( GAiDArea_HGL );
			GAiDArea = NULL;
			return(0);
		}
		
		GAiDicLine += get_aidic_line( ai_dic_name );
	}
	
	/* [U[t@Cꍇ͍Ōɓǂݍ */
	if( user_flg == 1 ){
		strcpy( ai_dic_name, GlobalPath );
		strcat( ai_dic_name, userfile.cFileName );
		if( read_file( &read_pnt, ai_dic_name, userfile.nFileSizeLow ) != 0 ){
			free( GAiDArea_HGL );
			GAiDArea = NULL;
			return(0);
		}
		GAiDicLine += get_aidic_line( ai_dic_name );
	}
	
	/* ߂l͎TCY */
	return( ai_dic_size );
	
}

/************************************************************************/
/*			t@C̃Xg쐬iXgt@C̕j			*/
/************************************************************************/
int get_dic_list1( char* listname, char* buf, char *list[], int max_size, int max_num )
{
	
	FILE* fp_list;
	char filepath[1024];
	int loop_cnt;
	int loop_cnt2;
	int size;
	int list_num;
	int flg;
	
	/* Xg̈揉 */
	for( loop_cnt = 0; loop_cnt < max_num; loop_cnt++ ){
		list[loop_cnt] = NULL;
	}
	
	/* Xgt@C̃tpX쐬 */
	strcpy( filepath, GlobalPath );
	strcat( filepath, listname );
	
	/* Xgt@CI[v */
	fp_list = fopen( filepath, "rb" );
	if( fp_list == NULL )return(0);
	
	/* t@Cǂݍ */
	size = filelength( fileno( fp_list ) );
	
	/* t@CTCYȌꍇ͏I */
	if( size == 0 ){
		fclose(fp_list);
		return(0);
	}
	
	if( size > max_size )size = max_size;
	fread( buf, size, 1, fp_list );
	*(buf+size) = '\0';
	*(buf+size+1) = '\0';
	fclose(fp_list);
	
	/* Ps擾 */
	list_num = 0;
	flg = 1;
	for( loop_cnt = 0; loop_cnt < size; loop_cnt++ ){
		/* s{s̏ꍇ̓tO𗧂Ă */
		if( *(buf+loop_cnt) == '\r' ){
			*(buf+loop_cnt) = '\0';
			flg = 1;
			continue;
		}
		if( *(buf+loop_cnt) == '\n' ){
			*(buf+loop_cnt) = '\0';
			flg = 1;
			continue;
		}
		
		/* sł͖ĈꕶOsꍇ͍sȂ̂Ń|Cg擾 */
		if( flg == 1 ){
			list[list_num] = buf+loop_cnt;
			list_num++;
			flg = 0;
		}
		
	}
	
	/* 擾t@C݂t@C`FbN */
	for( loop_cnt = 0; list[loop_cnt] != NULL; loop_cnt++ ){
		/* Yt@C̃tpX쐬 */
		strcpy( filepath, GlobalPath );
		strcat( filepath, list[loop_cnt] );
		
		/* t@C݂ꍇ͎̃`FbN */
		if( access(filepath,0) == 0 )continue;
		
		/* t@C݂͑Ȃ̂ŃXgl߂ */
		for( loop_cnt2 = loop_cnt; list[loop_cnt2] != NULL; loop_cnt2++ ){
			list[loop_cnt2] = list[loop_cnt2+1];
		}
	}
	
	return(0);
	
}


/************************************************************************/
/*			t@C̃Xg쐬iXgt@CȊO̕j			*/
/************************************************************************/
int get_dic_list2( char* file_base, char* list_buf, char* list[] )
{
	char ai_dic_name_org[1024];
	char* now_point;
	WIN32_FIND_DATA filestate;
	int loop_cnt;
	int list_num;
	
	/* `ht@C쐬iChJ[hj */
	strcpy( ai_dic_name_org, GlobalPath );
	strcat( ai_dic_name_org, file_base );
	strcat( ai_dic_name_org, "*.*" );
	
	/* Xg̃f[^yэŏIʒu擾 */
	for( loop_cnt = 0; list[loop_cnt] != NULL; loop_cnt++ );
	list_num = loop_cnt;
	if( list_num != 0 ){
		now_point = list[loop_cnt-1];
		while( *now_point != '\0' )now_point++;
		now_point++;
	}
	else{
		now_point = list_buf;
		*now_point = '\0';
	}
	
	/* Pt@Cڎ擾 */
	HANDLE handle = FindFirstFile( ai_dic_name_org, &filestate );
	
	/* Pt@C΃XgǉȂ */
	if( handle == INVALID_HANDLE_VALUE )return(0);
	
	/* Pt@Cڂ̃t@C`FbN */
	if( chk_esedicfile( filestate.cFileName ) == 0 ){
		for( loop_cnt = 0; loop_cnt < list_num; loop_cnt++ ){
			if( strcmp( filestate.cFileName, list[loop_cnt] ) == 0 )break;
		}
		if( loop_cnt == list_num ){
			/* XgɃt@Co^ */
			strcpy( now_point, filestate.cFileName );
			list[list_num] = now_point;
			list_num++;
			list[list_num] = NULL;
			while( *now_point != '\0' )now_point++;
			now_point++;
		}
	}
	
	/* Qt@Cڈȍ~擾 */
	while( FindNextFile( handle, &filestate ) == TRUE ){
		if( chk_esedicfile( filestate.cFileName ) == 0 ){
			for( loop_cnt = 0; loop_cnt < list_num; loop_cnt++ ){
				if( strcmp( filestate.cFileName, list[loop_cnt] ) == 0 )break;
			}
			if( loop_cnt == list_num ){
				/* XgɃt@Co^ */
				strcpy( now_point, filestate.cFileName );
				list[list_num] = now_point;
				list_num++;
				list[list_num] = NULL;
				while( *now_point != '\0' )now_point++;
				now_point++;
			}
		}
	}
	
	/* nhN[Y */
    FindClose(handle);
	
	return( 0 );
	
}


/************************************************************************/
/*				t@C擾iChJ[hΉj					*/
/************************************************************************/
int get_dicfile_info( char* org, WIN32_FIND_DATA* aifile, int no )
{
	WIN32_FIND_DATA filestate;
	int file_no = -1;
	
	/* Pt@Cڎ擾 */
	HANDLE handle = FindFirstFile( org, &filestate );
	
	/* Pt@Cꍇ */
	if( handle == INVALID_HANDLE_VALUE )return(-1);
	
	/* Pt@Cڂt@CǂmF */
	if( chk_esedicfile( filestate.cFileName ) == 0 )file_no++;
	
	/* Pt@CڂYt@C̏ꍇ */
	if( no == file_no ){
		memcpy( aifile, &filestate, sizeof(WIN32_FIND_DATA) );
		FindClose(handle);
		return(0);
	}
	
	/* Qt@Cڈȍ~擾 */
	while( FindNextFile( handle, &filestate ) == TRUE ){
		if( chk_esedicfile( filestate.cFileName ) == 0 )file_no++;
		
		/* Yt@Cǂ */
		if( file_no == no ){
			memcpy( aifile, &filestate, sizeof(WIN32_FIND_DATA) );
			FindClose(handle);
			return(0);
		}
	}
	
	/* nhN[Y */
	FindClose(handle);
	
	/* w肎傫߂ꍇ */
	return(-2);
	
}


/************************************************************************/
/*				t@Cgq"TXT" or "DIC" ǂ					*/
/************************************************************************/
int chk_esedicfile( char* filename )
{
	
	char* p_wrk;
	unsigned char wrk[3];
	
	/* ԉE[ɂ'.'̈ʒu擾i玫ł͂Ȃj */
	p_wrk = strrchr( filename, '.' );
	if( p_wrk == NULL )return(1);
	
	/* RoCg擾iȏ̓`FbNȂj */
	memcpy( wrk, p_wrk+1, 3 );
	
	/* 啶 */
	if( wrk[0] >= 'a' && wrk[0] <= 'z' )wrk[0] -= (char)('a' - 'A');
	if( wrk[1] >= 'a' && wrk[1] <= 'z' )wrk[1] -= (char)('a' - 'A');
	if( wrk[2] >= 'a' && wrk[2] <= 'z' )wrk[2] -= (char)('a' - 'A');
	
	/* gqr */
	if( memcmp( wrk, "TXT", 3 ) == 0 )return(0);
	if( memcmp( wrk, "DIC", 3 ) == 0 )return(0);
	
	/* LȊO̊gq̂Ŏł͂Ȃ */
	return(1);
	
}


/************************************************************************/
/*				t@Cǂݍ										*/
/************************************************************************/
int read_file( char** pnt, char* filename, unsigned long size )
{
	
	FILE* fp;
	char wrk[64];
	char* buf = *pnt;
	
	/* I[v */
	fp = fopen( filename, "rb" );
	if( fp == NULL ){
		return(1);
	}
	
	/* t@C̃wb_mF */
	fread( wrk, 9, 1, fp );
	if( memcmp( wrk, "ESESHIORI", 9 ) != 0 ){
		/* Ít@Cł͂Ȃ */
		fseek( fp, 0, SEEK_SET );
		while( size > 8192 ){
			fread( buf, 8192, 1, fp );
			size -= 8192;
			buf  += 8192;
		}
		fread( buf, (short)size, 1, fp );
		buf += (short)size;
	}
	else{
		/* Ít@Cł */
		char add;
		int loop_cnt;
		
		/* ɍۂČZ錳̒l */
		fread( &add, sizeof(char), 1, fp );
		
		/* wb_␳ */
		size -= 32;
		fseek( fp, 32, SEEK_SET );
		
		/* USoCg̃ubNɕ */
		while( size > 64 ){
			fread( wrk, 64, 1, fp );
			for( loop_cnt = 0; loop_cnt < 64; loop_cnt++ ){
				wrk[loop_cnt] -= (char)((int)(add+loop_cnt*5)%256);
			}
			memcpy( buf, wrk, 64 );
			size-=64L;
			buf +=64;
			add += (char)3;
			
		}
		
		/* t@CI[̒[̕ */
		fread( wrk, (int)size, 1, fp );
		for( loop_cnt = 0; loop_cnt < (int)size; loop_cnt++ ){
			wrk[loop_cnt] -= (char)((int)(add+loop_cnt*5)%256);
		}
		memcpy( buf, wrk, (int)size );
		buf += (short)size;
	}
	
	/* I[NULLR[htisR[hEOF΍j */
	memcpy( buf, "\0\0", 2 );
	
	/* ǂݍݏIʒuԂ */
	*pnt = buf + 2L;
	
	/* N[Y */
	fclose( fp );
	
	return(0);

}

/************************************************************************/
/*				t@C̍s擾iRgs͐Ȃj			*/
/************************************************************************/
unsigned long get_aidic_line( char* filename )
{
	FILE* fp;
	char wrk[2048];
	unsigned long line_num = 0;
	
	/* I[v */
	fp = fopen( filename, "rb" );
	if( fp == NULL ){
		return(0);
	}
	
	/* t@C̃wb_mF */
	fread( wrk, 9, 1, fp );
	if( memcmp( wrk, "ESESHIORI", 9 ) != 0 ){
		/* Ít@Cł͂Ȃ */
		fseek( fp, 0, SEEK_SET );
		
		/* s擾iRgs͔j */
		while( fgets( wrk, 2048, fp ) != NULL ){
			
			/* Rgsǂf */
			if( wrk[0] == '\0' ||
				wrk[0] == 0x1a ||
				wrk[0] == 0x0d && wrk[1] == 0x0a ||
				wrk[0] == '/' && wrk[1] == '/' )continue;
			
			/* sǂ̔fis^uIF\rj */
			if( wrk[0] == 0x09 ||
				memlcmp( wrk, "$ELSE" ) == 0 ||
				memlcmp( wrk, "$ENDIF" ) == 0 )continue;
			
			/* RgsȊOJEg */
			line_num++;
		}
	}
	else{
		/* Ít@Cł */
		fseek( fp, 10, SEEK_SET );
		
		/* wb_̍s擾 */
		fread( (char *)&line_num, sizeof(unsigned long), 1, fp );
	}
	
	/* N[Y */
	fclose( fp );
	
	return( line_num );
}


/************************************************************************/
/*				Gg`FbNyуGgmnZo				*/
/************************************************************************/
int check_entry( char* entry, char *entry_type, unsigned long *entry_no )
{
	/* Ggł͂ȂG[I */
	if( *entry != '#' )return(1);
	
	/* Gg^Cv擾 */
	*entry_type = *(entry+1);
	
	/* ʏGgǂ؂蕪 */
	if( memlcmp( entry, "##RESP" ) == 0 ){ 
		/* getresponsep̃GgƔFAAԂU */
		*entry_no = GResponseEntryNo;
		GResponseEntryNo++;
	}
	else if( memlcmp( entry, "##EVNT" ) == 0 ){
		/* Cxgp̃GgƔFAAԂU */
		*entry_no = GEventEntryNo + 0x10000;
		GEventEntryNo++;
	}
	else if( memlcmp( entry, "##GETS" ) == 0 ){
		/* Pp̃GgƔFAAԂU */
		*entry_no = GStringEntryNo + 0x20000;
		GStringEntryNo++;
	}
	else if( memlcmp( entry, "##REQUEST" ) == 0 ){
		/* SHIORI/3.0NGXg̃GgƔFAAԂU */
		*entry_no = GRequestEntryNo + 0x30000;
		GRequestEntryNo++;
	}
	else{
		/* ʏGgƔFAAԂU */
		*entry_no = GNormalEntryNo;
		GNormalEntryNo++;
	}
	
	return(0);
}


/************************************************************************/
/*				ʏGge[u쐬								*/
/************************************************************************/
get_entry_table( void )
{
	StrDicPnt* p_ai_dic = GAiDic;
	long loop_cnt;
	long loop_cnt2;
	long loop_cnt3;
	long entry_num;
	long entry_num_wrk;
	long now_entry;
	int len = 0;
	int lenwrk;
	int entry_no;
	
	/* Ggő咷擾 */
	entry_num = 0;
	for( loop_cnt = 0; loop_cnt < (long)GAiDicLine; loop_cnt++,p_ai_dic++ ){
		if( p_ai_dic->entry_type != ' ' )continue;
		if( *(p_ai_dic->string+1) == '#' )continue;
		lenwrk = strlen( p_ai_dic->string );
		if( lenwrk > len )len = lenwrk;
		entry_num++;
	}
	len--;		//'#'͊܂܂Ȃ̂ŁB
	
	StrEntryList* entry_list_wrk;
	StrEntryList* entry_list_wrk2;
	
	GEntryListString = (char*)malloc( (long)(len+2) * (long)(len+1) * entry_num );
	if( GEntryListString == NULL ){
		return(1);
	}
	
	GEntryList = (StrEntryList*)malloc( sizeof(StrEntryList) * (long)(len+1) * entry_num );
	if( GEntryList == NULL ){
		free( GEntryListString );
		GEntryListString = NULL;
		return(1);
	}
	
	for( loop_cnt = 0; loop_cnt < (long)(len+2) * (long)len * entry_num; loop_cnt++ ){
		*(GEntryListString + loop_cnt ) = '\0';
	}
	for( loop_cnt = 0; loop_cnt < (long)(len+1) * entry_num; loop_cnt++ ){
		(GEntryList+loop_cnt)->string = GEntryListString+loop_cnt*(long)(len+2);
		(GEntryList+loop_cnt)->start_no = -1;
		(GEntryList+loop_cnt)->end_no = -1;
	}
	
	/* 擾ɃGgZbg */
	entry_list_wrk = GEntryList;
	p_ai_dic = GAiDic;
	for( loop_cnt = 0; loop_cnt < (long)GAiDicLine; loop_cnt++,p_ai_dic++ ){
		if( p_ai_dic->entry_type != ' ' )continue;
		if( *(p_ai_dic->string+1) == '#' )continue;
		strcpy( entry_list_wrk->string, p_ai_dic->string+1 );
		entry_list_wrk->start_no = 0;
		entry_list_wrk->end_no = 0;
		entry_list_wrk++;
	}
	
	/* YGgAt@xbgɃ\[g */
	qsort( (void*)GEntryList, entry_num, sizeof(StrEntryList), chk_entry_sort1 );
	
	/* dGg͏ */
	entry_list_wrk = GEntryList;
	for( ; entry_list_wrk->start_no != -1; entry_list_wrk++ ){
		if( strcmp( entry_list_wrk->string, (entry_list_wrk+1)->string ) == 0 ){
			entry_num--;
			entry_list_wrk2 = entry_list_wrk+1;
			for( ; entry_list_wrk2->start_no != -1; entry_list_wrk2++ ){
				memcpy( (char*)entry_list_wrk2, (char*)(entry_list_wrk2+1), sizeof(StrEntryList) );
			}
		}
	}
	
	/* Ggɑ΂ăioO */
	entry_no = 1;
	entry_list_wrk = GEntryList;
	for( ; entry_list_wrk->start_no != -1; entry_list_wrk++ ){
		entry_list_wrk->start_no = entry_no;
		entry_list_wrk->end_no = entry_no;
		entry_no++;
	}
	
	/* AX^XNt̃GgSč쐬 */
	/* ʏGgɑ΂ďɍs */
	entry_num_wrk = 0;
	for( loop_cnt = 0; loop_cnt < entry_num; loop_cnt++ ){
		char moto[1024];
		int start_wrk;
		int end_wrk;
		
		strcpy( moto, (GEntryList+loop_cnt)->string );
		strcat( moto, "*" );
		lenwrk = strlen( moto );
		
		/* ԁ{AX^`擪PoCg{AX^܂ō */
		for( loop_cnt2 = lenwrk; loop_cnt2 > 1; loop_cnt2-- ){
		
			/* ɍ쐬ς݂ł͂Ȃ`FbN */
			entry_list_wrk = GEntryList + entry_num;
			for( ; entry_list_wrk->start_no != -1; entry_list_wrk++ ){
				if( strcmp( moto, entry_list_wrk->string ) == 0 ){
					loop_cnt2 = 0;
					break;
				}
			}
			if( loop_cnt2 == 0 )continue;
			
			/* VKȂ̂łnjGgio[͈̔͂擾 */
			lenwrk = strlen( moto );
			moto[lenwrk-1] = '\0';
			start_wrk = -1;
			end_wrk = -1;
			for( loop_cnt3 = 0; loop_cnt3 < entry_num; loop_cnt3++ ){
				if( memlcmp( (GEntryList+loop_cnt3)->string, moto ) == 0 ){
					if( start_wrk == -1 )start_wrk = (GEntryList+loop_cnt3)->start_no;
					end_wrk = (GEntryList+loop_cnt3)->end_no;
					continue;
				}
				if( start_wrk != -1 )break;
			}
			
			/* Xgɒǉ */
			strcat( moto, "*" );
			strcpy( entry_list_wrk->string, moto );
			entry_list_wrk->start_no = start_wrk;
			entry_list_wrk->end_no = end_wrk;
			entry_num_wrk++;
			
			/* ̃AX^tGg쐬 */
			lenwrk = strlen( moto );
			moto[lenwrk-2] = '\0';
			strcat( moto, "*" );
		
		}
		
	}
	
	entry_num += entry_num_wrk;
	
	/* f[^s̃GgԍC */
	p_ai_dic = GAiDic;
	now_entry = 0;
	for( loop_cnt = 0; loop_cnt < (long)GAiDicLine; loop_cnt++,p_ai_dic++ ){
		if( p_ai_dic->entry_type == ' ' ){
			if( *(p_ai_dic->string+1) == '#' ){
				/* X|XGg̏ꍇ͒l̏C͂Ȃ */
				now_entry = -1;
				continue;
			}
			else{
				/* ʏGgȂ̂ŃGgXgƏƍ */
				entry_list_wrk = GEntryList;
				for( ; entry_list_wrk->start_no != -1; entry_list_wrk++ ){
					if( strcmp( (p_ai_dic->string)+1, entry_list_wrk->string ) != 0 )continue;
					else{
						now_entry = entry_list_wrk->start_no;
						p_ai_dic->entry_no = now_entry;
						break;
					}
				}
				continue;
			}
		}
		
		/* X|XGgf[^̏ꍇ͒lCȂ */
		if( now_entry == -1 )continue;
		
		/* ʏGg̏ꍇ͒lC */
		p_ai_dic->entry_no = now_entry;
		
	}
	
	/* At@xbgtŃ\[g */
	qsort( (void*)GEntryList, entry_num, sizeof(StrEntryList), chk_entry_sort2 );
	
	return(0);

}




/************************************************************************/
/*				ʏGge[u\[giAt@xbgj		*/
/************************************************************************/
int chk_entry_sort1( const void* list1, const void* list2 )
{
	
	StrEntryList* entwrk1 = (StrEntryList*)list1;
	StrEntryList* entwrk2 = (StrEntryList*)list2;
	char* p_wrk1 = entwrk1->string;
	char* p_wrk2 = entwrk2->string;
	
	return( strcmp( p_wrk1, p_wrk2 ) );
	
}


/************************************************************************/
/*				ʏGge[u\[giAt@xbg~j		*/
/************************************************************************/
int chk_entry_sort2( const void* list1, const void* list2 )
{
	
	StrEntryList* entwrk1 = (StrEntryList*)list1;
	StrEntryList* entwrk2 = (StrEntryList*)list2;
	char* p_wrk1 = entwrk1->string;
	char* p_wrk2 = entwrk2->string;
	
	return( -(strcmp( p_wrk1, p_wrk2 )) );
	
}


/************************************************************************/
/* 						ŗL^OGAmہE						*/
/************************************************************************/
int init_koyu_tag(void)
{
	
	int comstr_num = 0;
	int comblock_num = 0;
	int comword_num = 0;
	int loop_cnt;
	int loop_cnt_wrk;
	
	GStrName = (StrName*)malloc( sizeof(StrName)*PROPER_ENTRY_NUM );
	if( GStrName != NULL ){
		char tagwrk[20];
		for( loop_cnt = 0; loop_cnt < PROPER_ENTRY_NUM; loop_cnt++ ){
			GStrName[loop_cnt].string = NULL;
			GStrName[loop_cnt].tag[0] = '\0';
			
			/* S[XgEPS[XgEhWndS */
			if( loop_cnt < 6 ){
				GStrName[loop_cnt].string = (char*)malloc(1024);
				if( GStrName[loop_cnt].string != NULL ){
					
					switch( loop_cnt ){
						case 0:
							strcpy( GStrName[loop_cnt].tag, "$sakura" );
							break;
						case 1:
							strcpy( GStrName[loop_cnt].tag, "$kero" );
							break;
						case 2:
							strcpy( GStrName[loop_cnt].tag, "$hwnd_sakura" );
							break;
						case 3:
							strcpy( GStrName[loop_cnt].tag, "$hwnd_kero" );
							break;
						case 4:
							strcpy( GStrName[loop_cnt].tag, "$hwnd_bsakura" );
							break;
						case 5:
							strcpy( GStrName[loop_cnt].tag, "$hwnd_bkero" );
							break;
					}
					*(GStrName[loop_cnt].string) = '\0';
				}
				continue;
			}
			
			/* Reference0`7 */
			if( loop_cnt < PENTRY_REFERENCE + 6 ){
				GStrName[loop_cnt].string = (char*)malloc(1024);
				if( GStrName[loop_cnt].string != NULL ){
					sprintf( tagwrk, "$ref%d", loop_cnt - 6 );
					strcpy( GStrName[loop_cnt].tag, tagwrk );
				}
				continue;
			} 
			
			/* COMMUNICATEpϐݒ */
			loop_cnt_wrk = ( loop_cnt - PENTRY_REFERENCE - 6 ) % 41;
			
			/* ubN */
			if( loop_cnt_wrk < PENTRY_COM_B_NUM ){
				GStrName[loop_cnt].string = NULL;
				sprintf( tagwrk, "$comblock%d_%d", comstr_num+1, comblock_num+1 );
				strcpy( GStrName[loop_cnt].tag, tagwrk );
				comblock_num++;
				continue;
			}
			
			/* [h */
			if( loop_cnt_wrk < PENTRY_COM_B_NUM+PENTRY_COM_W_NUM ){
				GStrName[loop_cnt].string = NULL;
				sprintf( tagwrk, "$comword%d_%d", comstr_num+1, comword_num+1 );
				strcpy( GStrName[loop_cnt].tag, tagwrk );
				comword_num++;
				continue;
			}
			
			/* ͕{ */
			if( loop_cnt_wrk >= PENTRY_COM_B_NUM+PENTRY_COM_W_NUM ){
				GStrName[loop_cnt].string = NULL;
				sprintf( tagwrk, "$comstr%d", comstr_num+1 );
				strcpy( GStrName[loop_cnt].tag, tagwrk );
				comstr_num++;
				if( comstr_num > PENTRY_COM_NUM )break;
				comblock_num = 0;
				comword_num = 0;
				continue;
			}
			
			break;
			
		}
		GStrNameNum = PROPER_ENTRY_NUM;
	}
	else{
		GStrNameNum = 0;
	}
	
	return(0);
	

}


/************************************************************************/
/* 						ŗL^OGAJ								*/
/************************************************************************/
int end_koyu_tag(void)
{
	int loop_cnt;
	
	for( loop_cnt = 0; loop_cnt < PROPER_ENTRY_NUM; loop_cnt++ ){
		if( GStrName[loop_cnt].string != NULL ){
			free( GStrName[loop_cnt].string );
		}
	}
	
	if( GStrName != NULL )free( (char*)GStrName );
	
	return(0);
	
}


/************************************************************************/
/* 			͂ꂽɑ΂ĕԎsȂ						*/
/************************************************************************/
int get_response( char* input_buf, char* output_buf )
{
	
	char wrk[7];
	
	unsigned long loop_cnt;
	int loop_cnt2;
	
	/* wb_R[h */
	GHeadCode = 200;
	
	/* ͕No.100̃GAɋL */
	if( GStack[PUSH_EVENT_ALLSENTENCE] != NULL )free(GStack[PUSH_EVENT_ALLSENTENCE]);
	if( ( GStack[PUSH_EVENT_ALLSENTENCE] = (char*)malloc( strlen(input_buf)+1 )) != NULL ){
		/* eRs[ */
		strcpy( GStack[PUSH_EVENT_ALLSENTENCE], input_buf );
	}
	else{
		GStack[PUSH_EVENT_ALLSENTENCE] = NULL;
	}
	
	/* COMMUNICATEϐ[N */
	for( loop_cnt2 = 0; loop_cnt2 < PENTRY_COM_B_NUM; loop_cnt2++ )GComBlock[loop_cnt2] = NULL;
	for( loop_cnt2 = 0; loop_cnt2 < PENTRY_COM_W_NUM; loop_cnt2++ )GComWord[loop_cnt2] = NULL;
	
	/* eCOMMUNICATEGg͕Ɣr */
	log_write_user( "--- chk start ---", "ese_talk.log", GTalkLogLocal );
	log_write_user( input_buf, "ese_talk.log", GTalkLogLocal );
	for( loop_cnt = 0; loop_cnt < GResponseEntryNo; loop_cnt++ ){
		if( check_response_entry( input_buf, loop_cnt, "##RESP", 1 ) == 1 ){
			/* COMMUNICATEϐZbg */
			set_comm_arg( input_buf );
			
			/* YGg̃f[^x[Xɂǂ쐬 */
			memcpy( wrk, "%#", 2 );
			ulong_to_str( loop_cnt, &wrk[2] );
			get_rnd_com_sentence( wrk, output_buf, input_buf );
			break;
		}
		for( loop_cnt2 = 0; loop_cnt2 < PENTRY_COM_B_NUM; loop_cnt2++ ){
			if( GComBlock[loop_cnt2] != NULL ){
				free(GComBlock[loop_cnt2]);
				GComBlock[loop_cnt2] = NULL;
			}
		}
		for( loop_cnt2 = 0; loop_cnt2 < PENTRY_COM_W_NUM; loop_cnt2++ ){
			if( GComWord[loop_cnt2] != NULL ){
				free(GComWord[loop_cnt2]);
				GComWord[loop_cnt2] = NULL;
			}
		}
		
	}
	GTalkLog = 0;
	
	/* ɊYGgtȂA*/
	/* Gg͂Ăf[^̏ꍇ204Ԃ */
	if( loop_cnt == GResponseEntryNo || *output_buf == '\0'  ||
		memlcmp( output_buf, "ESESHIORI ERROR" ) == 0 ){
		return(204);
	}
	else return(GHeadCode);
	
}


/************************************************************************/
/* 			͂ꂽCxgɑ΂ăX|XsȂ				*/
/************************************************************************/
int get_event_res( char* input_buf, char* output_buf )
{
	
	char wrk[7];
	
	unsigned long loop_cnt;
	
	/* wb_R[h */
	GHeadCode = 200;
	
	/* ͕No.100̃GAɋL */
	if( GStack[PUSH_EVENT_ALLSENTENCE] != NULL )free(GStack[PUSH_EVENT_ALLSENTENCE]);
	if( ( GStack[PUSH_EVENT_ALLSENTENCE] = (char*)malloc( strlen(input_buf)+1 )) != NULL ){
		/* eRs[ */
		strcpy( GStack[PUSH_EVENT_ALLSENTENCE], input_buf );
	}
	else{
		GStack[PUSH_EVENT_ALLSENTENCE] = NULL;
	}
	
	/* eCxgGg͕Ɣr */
	for( loop_cnt = 0; loop_cnt < GEventEntryNo; loop_cnt++ ){
		if( check_response_entry( input_buf, loop_cnt, "##EVNT", 0 ) == 1 ){
			/* YGg̃f[^x[Xɂǂ쐬 */
			memcpy( wrk, "%#", 2 );
			ulong_to_str( loop_cnt + 0x10000, &wrk[2] );
			get_rnd_com_sentence( wrk, output_buf, input_buf );

			break;
		}
		
	}
	
	/* ɊYGgtȂA*/
	/* Gg͂Ăf[^̏ꍇ204Ԃ */
	if( loop_cnt == GEventEntryNo ||
		memlcmp( output_buf, "ESESHIORI ERROR" ) == 0 ){
		return(204);
	}
	else return(GHeadCode);
	
}


/************************************************************************/
/* 			͂ꂽIDɑ΂ĕԂ							*/
/************************************************************************/
int get_simple_string( char* input_buf, char* output_buf )
{
	
	char wrk[7];
	
	unsigned long loop_cnt;
	unsigned long loop_cnt2;
	
	/* wb_R[h */
	GHeadCode = 200;
	
	/* ePGg͕Ɣr */
	for( loop_cnt = 0; loop_cnt < GStringEntryNo; loop_cnt++ ){
		if( check_response_entry( input_buf, loop_cnt, "##GETS", 0 ) == 1 ){
			/* YGg̃f[^SĎ擾iKvȂAj */
			StrDicPnt* p_ai_dic = GAiDic;
			memcpy( wrk, "%#", 2 );
			*output_buf = '\0';
			int cnt = 0;
			for( loop_cnt2 = 0; loop_cnt2 < GAiDicLine; loop_cnt2++ ){
				if( (p_ai_dic+loop_cnt2)->entry_type != '#' )continue;
				if( (p_ai_dic+loop_cnt2)->entry_no != loop_cnt+0x20000 )continue;
				strcat( output_buf, (p_ai_dic+loop_cnt2)->string );
				strcat( output_buf,"\2" );
				cnt++;
			}
			/* Pŝ݂̏ꍇ͍Ō'\2'폜iQsȏ͍Ō'\2'Kvj */
			if( cnt == 1 )*(output_buf+strlen(output_buf)-1) = '\0';
			
			/* ߏA֐ */
			make_dokoitsu( output_buf, input_buf, REPLACE_USE );
			
			break;
		}
		
	}
	
	/* ɊYGgtȂA*/
	/* Gg͂Ăf[^̏ꍇ204Ԃ */
	if( loop_cnt == GStringEntryNo || *output_buf == '\0' ||
		memlcmp( output_buf, "ESESHIORI ERROR" ) == 0 ){
		return(204);
	}
	else{
		return(GHeadCode);
	}
	
}


/************************************************************************/
/* 		͂ꂽSHIORI/3.0NGXgɑ΂ăX|XsȂ		*/
/************************************************************************/
int get_request_res( char* input_buf, char* output_buf )
{
	
	char wrk[7];
	
	unsigned long loop_cnt;
	
	/* wb_R[h */
	GHeadCode = 200;
	
	/* ͕No.100̃GAɋL */
	if( GStack[PUSH_EVENT_ALLSENTENCE] != NULL )free(GStack[PUSH_EVENT_ALLSENTENCE]);
	if( ( GStack[PUSH_EVENT_ALLSENTENCE] = (char*)malloc( strlen(input_buf)+1 )) != NULL ){
		/* eRs[ */
		strcpy( GStack[PUSH_EVENT_ALLSENTENCE], input_buf );
	}
	else{
		GStack[PUSH_EVENT_ALLSENTENCE] = NULL;
	}
	
	/* eCxgGg͕Ɣr */
	for( loop_cnt = 0; loop_cnt < GRequestEntryNo; loop_cnt++ ){
		if( check_response_entry( input_buf, loop_cnt, "##REQUEST", 0 ) == 1 ){
			/* YGg̃f[^x[Xɂǂ쐬 */
			memcpy( wrk, "%#", 2 );
			ulong_to_str( loop_cnt + 0x30000, &wrk[2] );
			get_rnd_com_sentence( wrk, output_buf, input_buf );

			break;
		}
		
	}
	
	/* ɊYGgtȂA*/
	/* Gg͂Ăf[^̏ꍇ204Ԃ */
	if( loop_cnt == GRequestEntryNo ||
		memlcmp( output_buf, "ESESHIORI ERROR" ) == 0 ){
		return(204);
	}
	else return(GHeadCode);
	
}

/************************************************************************/
/* 			wGg͂ꂽɍv邩`FbN		*/
/************************************************************************/
int check_response_entry( char* input_buf, unsigned long entry_no, char* type, int autotag_flg )
{
	char wrk[1030];
	char entry_str[4096];
	char logbuf[512];
	char* p_wrk1;
	char* p_wrk2;
	char* p_wrk3;
	char* p_start_pare;
	char* p_next_pare;
	char* p_input_wrk;
	char* block_history[PENTRY_COM_B_NUM];
	unsigned long word_no[PENTRY_COM_W_NUM];
	unsigned long loop_cnt;
	int block_tag_flg[PENTRY_COM_B_NUM];
	int loop_cnt2;
	int loop_cnt3;
	int max_pare_num;
	int min_distance;
	int max_distance;
	int point;
	int chkresp_point;
	int stack_no = PUSH_EVENT_START_NO;
	int comblock_no = 0;
	int comword_no = 0;
	int bhistory_point = 0;
	
	/* wGg̓i\mmj擾 */
	StrDicPnt* p_ai_dic = GAiDic;
	for( loop_cnt = 0; loop_cnt < GAiDicLine; loop_cnt++, p_ai_dic++ ){
		if( p_ai_dic->entry_type != ' ' )continue;
		if( memlcmp( p_ai_dic->string, type )!=0 )continue;
		if( entry_no == 0 ){
			strcpy( entry_str, p_ai_dic->string );
			break;
		}
		else entry_no--;
		
	}
	log_write_user( entry_str, "ese_talk.log", GTalkLogLocal );
	
	/* tȂꍇ̓G[I */
	if( loop_cnt == GAiDicLine ){
		return(2);
	}
	
	/* "="`FbNiΖɊYGgƌȂj */
	p_wrk1 = strchr( entry_str, '=' );
	if( p_wrk1 == NULL ){
		return(1);
	}
	
	/* ŏ"("`FbNiΖɊYGgƌȂj */
	p_wrk2 = strchr( p_wrk1+1, '(' );
	if( p_wrk2 == NULL ){
		return(1);
	}
	
	/* ۊʈɂă`FbNĂ */
	for( loop_cnt = 0; loop_cnt < 100; loop_cnt++ ){
		GStrChkResp[loop_cnt].chkstr = NULL;
		GStrChkResp[loop_cnt].no = -1;
	}
	for( loop_cnt = 0; loop_cnt < PENTRY_COM_B_NUM; loop_cnt++ )block_history[loop_cnt] = NULL;
	p_start_pare = p_wrk2;
	p_input_wrk = input_buf;
	chkresp_point = 0;
	max_pare_num = get_pare_num( p_start_pare );
	memset( block_tag_flg, 0, sizeof(int)*PENTRY_COM_B_NUM );
	for( loop_cnt3 = 0; loop_cnt3 < max_pare_num; loop_cnt3++ ){
		block_tag_flg[loop_cnt3] = chk_tag_in_block( p_start_pare, loop_cnt3 );
	}
	for( loop_cnt2 = 0; loop_cnt2 < max_pare_num; loop_cnt2++ ){
		/* Ώە擾 */
		p_next_pare = get_pare_point( p_start_pare, loop_cnt2 );
		if( p_next_pare == NULL )break;
		p_wrk1 = strchr( p_next_pare, '\"' );
		if( p_wrk1 == NULL )break;
		p_wrk3 = p_wrk1;	//"̈ʒuޔ
		
		memcpy( wrk, p_wrk1+1, 1024 );
		p_wrk2 = strchr( wrk, '\"' );
		if( p_wrk2 == NULL )break;
		*p_wrk2 = '\0';

		/* Ԋu擾 */
		min_distance = 0;
		max_distance = 9999;
		
		p_wrk1 = strchr( p_wrk2+1, ',' );
		if( p_wrk1 != NULL ){
			if( sscanf( p_wrk1+1, " %d", &min_distance ) != 1 )min_distance = 0;
			p_wrk2 = strchr( p_wrk1+1, ',' );
			if( p_wrk2 != NULL ){
				if( sscanf( p_wrk2+1, " %d", &max_distance ) != 1 )max_distance = 9999;
			}
		}
		
		/* ΏەmF */
		point = check_response_entry_sub( p_input_wrk, wrk, min_distance, max_distance, &word_no[0], loop_cnt2, block_history );
		if( point == -1 ){
			
			sprintf(logbuf,"		->Not agree.(%d)",loop_cnt2);
			log_write_user( logbuf, "ese_talk.log", GTalkLogLocal );
			
			/* ŏ̂̂vf[^ꍇ͏I */
			if( loop_cnt2 == 0 )break;
			
			/* ݈ʒuOɗLAł߂^OLubN܂ňړ */
			for( loop_cnt3 = loop_cnt2-1; loop_cnt3 >= 0; loop_cnt3-- ){
				if( block_tag_flg[loop_cnt3] == 1 ){
					loop_cnt2 = loop_cnt3 - 1;
					break;
				}
			}
			
			/* ^OLubNꍇ͂蒼ĂʂȂ̂ŏI */
			if( loop_cnt3 == -1 )break;
			
			/* `FbN銇ʋyу`FbNʒut^OLubN܂Ŗ߂ */
			for( loop_cnt = 99; loop_cnt >= 0; loop_cnt-- ){
				if( GStrChkResp[loop_cnt].no == loop_cnt2+1 ){
					p_input_wrk = GStrChkResp[loop_cnt].chkpoint;
					stack_no = GStrChkResp[loop_cnt].stack_no;
					comblock_no = GStrChkResp[loop_cnt].comblock_no;
					comword_no = GStrChkResp[loop_cnt].comword_no;
					bhistory_point = GStrChkResp[loop_cnt].bhistory_point;
					break;
				}
			}
			continue;
			
		}
		
		sprintf(logbuf,"	%s",wrk);
		log_write_user( logbuf, "ese_talk.log", GTalkLogLocal );
		
		/* 擾Lipj */
		if( ( GStrChkResp[chkresp_point].chkstr = (char*)malloc(strlen(wrk)+1) ) != NULL ){
			strcpy( GStrChkResp[chkresp_point].chkstr, wrk );
			GStrChkResp[chkresp_point].chkpoint = p_input_wrk;
			GStrChkResp[chkresp_point].no = loop_cnt2;
			GStrChkResp[chkresp_point].stack_no = stack_no;
			GStrChkResp[chkresp_point].comblock_no = comblock_no;
			GStrChkResp[chkresp_point].comword_no = comword_no;
			GStrChkResp[chkresp_point].bhistory_point = bhistory_point;
			chkresp_point++;
			
			/* obt@sI */
			if( chkresp_point == 99 ){
				break;
			}
		}
		/* 擾Lipj */
		if( bhistory_point < PENTRY_COM_B_NUM ){
			if( block_history[bhistory_point] != NULL )free( block_history[bhistory_point] );
			if( ( block_history[bhistory_point] = (char*)malloc(strlen(wrk)+1) ) != NULL ){
				strcpy( block_history[bhistory_point], wrk );
				bhistory_point++;
			}
			if( bhistory_point == PENTRY_COM_B_NUM )break;
		}
		
		/* 擾LiOpE݊j */
		if( stack_no < PUSH_EVENT_END_NO ){
			free_target_paragraph( stack_no );
			if( ( GStack[stack_no] = (char*)malloc( strlen(wrk)+1 )) != NULL ){
				/* eRs[ */
				strcpy( GStack[stack_no], wrk );
			}
			else{
				GStack[stack_no] = NULL;
			}
			stack_no++;
		}
		
		/* 擾Liϐ[Nj */
		if( comblock_no < PENTRY_COM_B_NUM && autotag_flg != 0 ){
			if( GComBlock[comblock_no] != NULL ){
				free(GComBlock[comblock_no]);
			}
			if( ( GComBlock[comblock_no] = (char*)malloc( strlen(wrk)+1 )) != NULL ){
				/* eRs[ */
				strcpy( GComBlock[comblock_no], wrk );
			}
			else{
				GComBlock[comblock_no] = NULL;
			}
			comblock_no++;
		}
		
		/* ^Ou̓^OeL */
		if( comword_no < PENTRY_COM_W_NUM && autotag_flg != 0 ){
			for( loop_cnt = 0; word_no[loop_cnt] != 0xffffffff; loop_cnt++ ){
				if( GComWord[comword_no] != NULL )free(GComWord[comword_no]);
				strcpy( wrk, (GAiDic+word_no[loop_cnt])->string );
				if( ( GComWord[comword_no+loop_cnt] = (char*)malloc( strlen(wrk)+1 )) != NULL ){
					/* eRs[ */
					strcpy( GComWord[comword_no+loop_cnt], wrk );
				}
				else{
					GComWord[comword_no+loop_cnt] = NULL;
				}
			}
			comword_no += loop_cnt;
		}
		
		/* ̏֍s */
		p_wrk1 = strchr( p_wrk3+1, '\"' );
		if( p_wrk1 == NULL )break;
		p_wrk2 = strchr( p_wrk1+1, ')' );
		if( p_wrk2 == NULL )break;
		p_input_wrk = p_input_wrk + point + strlen( wrk );
		
	}
	
	/* pGAJ */
	for( loop_cnt = 0; loop_cnt < 100; loop_cnt++ ){
		if( GStrChkResp[loop_cnt].chkstr != NULL ){
			free( GStrChkResp[loop_cnt].chkstr );
		}
	}
	for( loop_cnt = 0; loop_cnt < PENTRY_COM_B_NUM; loop_cnt++ ){
		if( block_history[loop_cnt] != NULL )free( block_history[loop_cnt] );
	}
	
	if( loop_cnt2 != max_pare_num ){
		/* r܂ł̋L͏ */
		
		for( loop_cnt2 = PUSH_EVENT_START_NO; loop_cnt2 < PUSH_EVENT_END_NO; loop_cnt2++ ){
			free_target_paragraph( loop_cnt2 );
		}
		
		return(2);
	}
	return(1);
	
}


/************************************************************************/
/* 			񒆂̊ۊʕ̐擾							*/
/************************************************************************/
int get_pare_num( char* buf )
{
	int flg = 0;
	int cnt;
	
	/* '"'ɒӂ'('𐔂 */
	cnt = 0;
	unsigned long len = strlen( buf );
	if( len > LINE_BUF_SIZE-1 )len = LINE_BUF_SIZE-1;
	for( unsigned long loop_cnt = 0; loop_cnt < len; loop_cnt++ ){
		if( *(buf+loop_cnt) == '\"' ){
			flg = (flg==0);
			continue;
		}
		
		/* _uNH[g̓`FbNȂ */
		if( flg == 1 )continue;
		
		/* ʂꍇ̓JEgAbv */
		if( *(buf+loop_cnt) == ')' )cnt++;
		
	}
	
	return(cnt);
	
}


/************************************************************************/
/* 			w肳ꂽԖڂ̊ۊʈʒu擾						*/
/************************************************************************/
char* get_pare_point( char* buf, int no )
{
	int flg = 0;
	
	/* '"'ɒӂ'('𐔂 */
	unsigned long len = strlen( buf );
	if( len > LINE_BUF_SIZE-1 )len = LINE_BUF_SIZE-1;
	for( unsigned long loop_cnt = 0; loop_cnt < len; loop_cnt++ ){
		/* _uNH[g`FbN */
		if( *(buf+loop_cnt) == '\"' ){
			flg = (flg==0);
			continue;
		}
		
		/* _uNH[g͖ */
		if( flg == 1 )continue;
		
		/* '('`FbN */
		if( *(buf+loop_cnt) == '(' ){
			if( no == 0 ){
				return( buf+loop_cnt );
			}
			else no--;
		}
		
		/* G[ */
		if( *(buf+loop_cnt) == '\r' ||
			*(buf+loop_cnt) == '\n' ||
			*(buf+loop_cnt) == '\0' ){
			return(NULL);
		}
		
	}
	
	/* G[ */
	return(NULL);
	
}


/************************************************************************/
/* 	w肳ꂽԖڂ̃ubNɃ^O݂邩ǂ`FbN		*/
/************************************************************************/
int chk_tag_in_block( char* buf, int no )
{
	int flg = 0;
	
	/* '"'ɒӂ'('𐔂 */
	unsigned long len = strlen( buf );
	if( len > LINE_BUF_SIZE-1 )len = LINE_BUF_SIZE-1;
	for( unsigned long loop_cnt = 0; loop_cnt < len; loop_cnt++ ){
		/* _uNH[g`FbN */
		if( *(buf+loop_cnt) == '\"' ){
			flg = (flg==0);
			continue;
		}
		
		/* wubÑ_uNH[gȂ̂Ń^O݂`FbN */
		if( flg == 1 && no == 0 ){
			/* ^Ȃ'%'݂邩ǂ */
			if( *(buf+loop_cnt) == '%' &&
				*(buf+loop_cnt+1) != '%' ){
				/* ݂̂ł̃ubN̓^OLƔf */
				return(1);
			}
		}
		
		/* ')'`FbN */
		if( *(buf+loop_cnt) == ')' ){
			/* YubNȂ̂'%'oɃubNGh܂ */
			/* Ă܂̂ŁÃubN̓^OƔf    */
			if( no == 0 ){
				return(0);
			}
			else no--;
		}
		
		/* G[ */
		if( *(buf+loop_cnt) == '\r' ||
			*(buf+loop_cnt) == '\n' ||
			*(buf+loop_cnt) == '\0' ){
			return(0);
		}
		
	}
	
	/* G[ */
	return(0);
	
}


/************************************************************************/
/* 			wGg͂ꂽɍv邩`FbN		*/
/*					rc = 0ȏ	: 								*/
/*						 -1		: 									*/
/*				chk_buf = v								*/
/************************************************************************/
int check_response_entry_sub( char* input_buf, char* chk_buf, int min, int max, unsigned long* word_no, int pare_no, char* block_history[] )
{

	
	char wrk[2048];
	char wrk2[2048];
	char wrk_tag[1024];
	char logbuf[512];
	char* p_wrk1;
	char* p_tag;
	char* p_tag2;
	char tag_type;
	char tag_type2;
	int entry_num;
	int tag_len;
	int tag_len2;
	int loop_cnt3;
	int chk_cnt;
	int chk_start_point;
	unsigned long start_no;
	unsigned long start_no2;
	unsigned long end_no;
	unsigned long end_no2;
	unsigned long data_num;
	unsigned long data_num2;
	unsigned long loop_cnt;
	unsigned long loop_cnt2;

	/* uꂽ^OԍԂ */
	for( loop_cnt = 0; loop_cnt < PENTRY_COM_W_NUM; loop_cnt++ ){
		*(word_no+loop_cnt) = 0xffffffff;
	}
	
	/* `FbN񒆂̃Gg^Ǒ擾 */
	entry_num = get_entry_tag_num(chk_buf);
	
	/* Gg^O̂ŒPɃ`FbN */
	if( entry_num == 0 ){
		/* ^ */
		strcpy( wrk, chk_buf );
		meta_to_char( wrk );
		
		/* `FbN */
		p_wrk1 = strstr( input_buf, wrk );
		
		if( p_wrk1 == NULL )return(-1);
		if( (int)(p_wrk1-input_buf) > max )return(-1);
		if( (int)(p_wrk1-input_buf) < min )return(-1);
		
		/* ߂lݒ肵Ė߂ */
		strcpy( chk_buf, wrk );

		return( (int)(p_wrk1-input_buf) );
		
	}
	
	/* Gg^O͈Ȃ̂Ń\Ń`FbN */
	if( entry_num == 1 ){
		
		/* ^Oʒu擾 */
		strcpy( wrk, chk_buf );
		for(;;){
			p_tag = strchr( wrk, '%' );
			if( *(p_tag+1) != '%' )break;
		}
		
		/* ȑO`FbNČʂmf̂̂A`FbNΏۂƂȂ̂ */
		loop_cnt3 = 0;
		for( chk_cnt = 0; chk_cnt < pare_no; chk_cnt++ ){
			for( ; loop_cnt3 < 99; loop_cnt3++ ){
				if( GStrChkResp[loop_cnt3].no != chk_cnt )continue;
				if( strcmp( block_history[chk_cnt], GStrChkResp[loop_cnt3].chkstr ) != 0 )continue;
					
				/* ݂̃ubNem聨̒iɉc[ʒum */
				break;
			}
			if( loop_cnt3 == 99 ){
				loop_cnt3 = 0;
				break;
			}
		}
		chk_start_point = loop_cnt3+1;
		
		/* Y^O̎f[^擾 */
		tag_type = *(p_tag+1);
		if( getstr_from_nmlentry( p_tag+1, &start_no, &end_no, &tag_len ) == 0 ){
			data_num = get_str_num( *(p_tag+1), start_no, end_no );
		}
		else{
			data_num = start_no = end_no = 0;
		}
		for( loop_cnt = 0; loop_cnt < data_num; loop_cnt++ ){
			strcpy( wrk, chk_buf );
			
			/* 擾Ēu */
			*word_no = get_ap_str( tag_type, start_no, end_no, loop_cnt, wrk_tag );
			tag_exchange( p_tag, wrk_tag, tag_len );
			
			/* ^ */
			meta_to_char( wrk );
			
			/* ȑO`FbNČʂmf̂̓`FbNȂ */
			for( loop_cnt3 = chk_start_point; loop_cnt3 < 99; loop_cnt3++ ){
				if( GStrChkResp[loop_cnt3].chkstr == NULL )break;
				if( GStrChkResp[loop_cnt3].no < pare_no )break;
				if( GStrChkResp[loop_cnt3].no > pare_no )continue;
				if( strcmp( GStrChkResp[loop_cnt3].chkstr, wrk ) == 0 ){
					loop_cnt3 = 200;
					break;
				}
			}
			if( loop_cnt3 == 200 )continue;
			
			sprintf(logbuf,"		%s",wrk);
			log_write_user( logbuf, "ese_talk.log", GTalkLogLocal );
			
			/* `FbN */
			p_wrk1 = strstr( input_buf, wrk );
			if( p_wrk1 == NULL )continue;
			if( (int)(p_wrk1-input_buf) > max )continue;
			if( (int)(p_wrk1-input_buf) < min )continue;
			
			/* ߂lݒ肵Ė߂ */
			strcpy( chk_buf, wrk );
			
			return( (int)(p_wrk1-input_buf) );
			
		}
		
		/* YȂ̂ŏI */
		*word_no = 0xffffffff;
		return(-1);
	}
	
	/* Gg^O͓Ȃ̂ŗ̑gݍ킹Ń`FbN */
	if( entry_num == 2 ){
		/* ^Oʒu擾 */
		strcpy( wrk, chk_buf );
		for(;;){
			p_tag = strchr( wrk, '%' );
			if( *(p_tag+1) != '%' ){
				for(;;){
					p_tag2 = strchr( p_tag+2, '%' );
					if( *(p_tag2+1) != '%' )break;
				}
				break;
			}
		}
		
		/* Y^O̎f[^擾 */
		tag_type = *(p_tag+1);
		tag_type2 = *(p_tag2+1);
		if( getstr_from_nmlentry( p_tag+1, &start_no, &end_no, &tag_len ) == 0 ){
			data_num = get_str_num( *(p_tag+1), start_no, end_no );
		}
		else{
			data_num = start_no = end_no = 0;
		}

		if( getstr_from_nmlentry( p_tag2+1, &start_no2, &end_no2, &tag_len2 ) == 0 ){
			data_num2 = get_str_num( *(p_tag2+1), start_no2, end_no2 );
		}
		else{
			data_num2 = start_no2 = end_no2 = 0;
		}


		for( loop_cnt2 = 0; loop_cnt2 < data_num2; loop_cnt2++ ){
			/* x[X擾 */
			strcpy( wrk, chk_buf );
			
			/* QԖڂ̃^O擾 */
			*(word_no+1) = get_ap_str( tag_type2, start_no2, end_no2, loop_cnt2, wrk_tag );
			
			/* QԖڂ̃^Ô݂ł܂`FbN|iʖڂȂQԖڃ^O蒼j */
			p_wrk1 = strstr( input_buf, wrk_tag );
			if( p_wrk1 == NULL )continue;
			
			/* ^Ou{ԕۑ */
			tag_exchange( p_tag2, wrk_tag, tag_len2 );
			strcpy( wrk2, wrk );
			
			for( loop_cnt = 0; loop_cnt < data_num; loop_cnt++ ){
				/* QԖڃ^Ô݋NςԂ̂̂擾 */
				strcpy( wrk, wrk2 );
			
				/* PԖڂ̃^O擾Ēu */
				*word_no = get_ap_str( tag_type, start_no, end_no, loop_cnt, wrk_tag );
				tag_exchange( p_tag, wrk_tag, tag_len );
				
				/* ^ */
				meta_to_char( wrk );
				
				/* ȑO`FbNČʂmf̂̓`FbNȂ */
				for( loop_cnt3 = 0; loop_cnt3 < 100; loop_cnt3++ ){
					if( GStrChkResp[loop_cnt3].chkstr == NULL )continue;
					if( GStrChkResp[loop_cnt].no != pare_no )continue;
					if( strcmp( GStrChkResp[loop_cnt].chkstr, wrk ) == 0 ){
						loop_cnt3 = 200;
					}
				}
				if( loop_cnt3 == 200 )continue;
				
				/* `FbN */
				p_wrk1 = strstr( input_buf, wrk );
				if( p_wrk1 == NULL )continue;
				if( (int)(p_wrk1-input_buf) > max )continue;
				if( (int)(p_wrk1-input_buf) < min )continue;
				
				/* ߂lݒ肵Ė߂ */
				strcpy( chk_buf, wrk );
				
				return( (int)(p_wrk1-input_buf) );
			}
		}
		
		/* YȂ̂ŏI */
		*word_no = 0xffffffff;
		*(word_no+1) = 0xffffffff;
		return(-1);
	}
	
	/* ^OGgOȏ゠ꍇ͏I */
	return(-1);
	
}

/************************************************************************/
/* 			񒆂̃Gg^O𐔂							*/
/************************************************************************/
int get_entry_tag_num( char* buf )
{
	
	char* p_wrk1;
	char* p_wrk2;
	int cnt = 0;
	
	p_wrk1 = buf;
	
	for(;;){
		p_wrk2 = strchr( p_wrk1, '%' );
		if( p_wrk2 == NULL )break;			//'%'ꍇ̓JEgI
		if( *(p_wrk2+1) == '%' ){
			p_wrk1 = p_wrk2+2;
			continue;						//^̏ꍇ͔΂
		}
		
		/* JEg𑝂₵Ď̃`FbN */
		cnt++;
		p_wrk1 = p_wrk2 + 1;
		
	}
	
	return(cnt);
	
}


/************************************************************************/
/* 			COMMUNICATEϐZbg								*/
/************************************************************************/
int set_comm_arg( char* input_buf )
{

	StrName *str_name_wrk;
	int loop_cnt;
	int loop_cnt2;

	/* COMMUNICATEϐŏIf[^̏ */
	for( loop_cnt = 0; loop_cnt < 41; loop_cnt++ ){
		str_name_wrk = &GStrName[loop_cnt+6+PENTRY_REFERENCE+41*(PENTRY_COM_NUM-1)];
		if( str_name_wrk->string != NULL ){
			free( str_name_wrk->string );
			str_name_wrk->string = NULL;
		}
	}
	
	/* COMMUNICATEϐf[^ړ */
	for( loop_cnt2 = PENTRY_COM_NUM-2; loop_cnt2 >= 0 ; loop_cnt2-- ){
		for( loop_cnt = 0; loop_cnt < 41; loop_cnt++ ){
			GStrName[loop_cnt+6+PENTRY_REFERENCE+41*(loop_cnt2+1)].string = GStrName[loop_cnt+6+PENTRY_REFERENCE+41*loop_cnt2].string;
		}
	}
	
	/* COMMUNICATEϐ擪Rs[ */
	for( loop_cnt2 = 0; loop_cnt2 < PENTRY_COM_B_NUM; loop_cnt2++ ){
		if( GComBlock[loop_cnt2] != NULL ){
			GStrName[6+PENTRY_REFERENCE+loop_cnt2].string = (char*)malloc( strlen( GComBlock[loop_cnt2] ) + 1 );
			if( GStrName[6+PENTRY_REFERENCE+loop_cnt2].string != NULL ){
				strcpy( GStrName[6+PENTRY_REFERENCE+loop_cnt2].string, GComBlock[loop_cnt2] );
			}
			free( GComBlock[loop_cnt2] );
			GComBlock[loop_cnt2] = NULL;
		}
		else{
			GStrName[6+PENTRY_REFERENCE+loop_cnt2].string = NULL;
		}
	}
	for( loop_cnt2 = 0; loop_cnt2 < PENTRY_COM_W_NUM; loop_cnt2++ ){
		if( GComWord[loop_cnt2] != NULL ){
			GStrName[6+PENTRY_REFERENCE+PENTRY_COM_B_NUM+loop_cnt2].string = (char*)malloc( strlen( GComWord[loop_cnt2] ) + 1 );
			if( GStrName[6+PENTRY_REFERENCE+PENTRY_COM_B_NUM+loop_cnt2].string != NULL ){
				strcpy( GStrName[6+PENTRY_REFERENCE+PENTRY_COM_B_NUM+loop_cnt2].string, GComWord[loop_cnt2] );
			}
			free( GComWord[loop_cnt2] );
			GComWord[loop_cnt2] = NULL;
		}
		else{
			GStrName[6+PENTRY_REFERENCE+PENTRY_COM_B_NUM+loop_cnt2].string = NULL;
		}
	}
	GStrName[6+PENTRY_REFERENCE+PENTRY_COM_B_NUM+PENTRY_COM_W_NUM].string = (char*)malloc(strlen(input_buf)+1);
	if( GStrName[6+PENTRY_REFERENCE+PENTRY_COM_B_NUM+PENTRY_COM_W_NUM].string != NULL ){
		strcpy( GStrName[6+PENTRY_REFERENCE+PENTRY_COM_B_NUM+PENTRY_COM_W_NUM].string, input_buf );
	}
	
	return(0);

}


/************************************************************************/
/* 			P񂾂iSSP΍j								*/
/************************************************************************/
void set_rand(void)
{
	
	if(RND_FLG == 0 ){
		srand( (unsigned)time( NULL ) );
	}
	rand();
	RND_FLG = 1;
}


/************************************************************************/
/*				FMOS[XgƂwHnd擾					*/
/************************************************************************/
int get_fmo(char* ghost, char* kero, int* hwnd, char* path, int no)
{

	int no_hwnd = 0;
	
	/* vZ̓sAw萔{PĂ */
	no++;
	
	/* FMOnhI[v */
	HANDLE GMapHndl=OpenFileMapping(FILE_MAP_READ,TRUE,"Sakura");
	if( GMapHndl != NULL ){
		/* 擾 */
		char* p_area = (char*)MapViewOfFile( GMapHndl, FILE_MAP_READ, 0, 0, 0);

		char wrk[4096];
		char md5[1024];
		char* p_hwnd_data = p_area+4;
		char* p_other_data;
		char* p_wrk;

		/* hwndڂԂɎ擾 */
		for(;;){
			/* PsRs[ */
			p_wrk = strstr( p_hwnd_data, "\r\n" );
			if( p_wrk != NULL ){
				memcpy( wrk, p_hwnd_data, (int)(p_wrk-p_hwnd_data) );
				wrk[(int)(p_wrk-p_hwnd_data)] = '\0';
			}
			else break;		/* I[܂ŗ */
			
			/* |C^ړ */
			p_hwnd_data = p_wrk + 2;
			
			/* hWndڂł͂Ȃꍇ͎̍s */
			p_wrk = strstr(wrk, "hwnd");
			if( p_wrk == NULL )continue;
			
			/* hWndڂ擾Ԗڂł͖ꍇ͎̍s */
			no_hwnd++;
			if( no != no_hwnd )continue;
			
			/* hWndl擾 */
			sscanf( p_wrk+5, "%d", hwnd );
			
			/* MD5l擾 */
			*p_wrk = '\0';
			strcpy( md5, wrk );
			
			/* MD5l̍ڂ擾 */
			*ghost = *kero = *path = '\0';
			p_other_data = p_area+4;
			for(;;){
				/* PsRs[ */
				p_wrk = strstr( p_other_data, "\r\n" );
				if( p_wrk != NULL ){
					memcpy( wrk, p_other_data, (int)(p_wrk-p_other_data) );
					wrk[(int)(p_wrk-p_other_data)] = '\0';
				}
				else break;		/* I[܂ŗ */
				
				/* |C^ړ */
				p_other_data = p_wrk + 2;
				
				/* MD5lȂڂ͔΂ */
				if( memlcmp( wrk, md5 ) != 0 )continue;
				
				/* sdwdpX擾 */
				p_wrk = strstr(wrk, "path");
				if( p_wrk != NULL ){
					strcpy( path, p_wrk+5 );
					continue;
				}
				
				/* ɂイ擾 */
				p_wrk = strstr(wrk, "keroname");
				if( p_wrk != NULL ){
					strcpy( kero, p_wrk+9 );
					continue;
				}
				
				/* S[Xg擾 */
				p_wrk = strstr(wrk, "name");
				if( p_wrk != NULL ){
					strcpy( ghost, p_wrk+5 );
				}
			}
			
			/* 擾̂ŏI */
			UnmapViewOfFile((void*)p_area);
			CloseHandle(GMapHndl);
			return(0);
		}
		
		/* 肭tȂ̂ŏI */
		UnmapViewOfFile((void*)p_area);
		CloseHandle(GMapHndl);
	}
	
	return(1);

}

/************************************************************************/
/*				݂̃S[Xgl擾							*/
/************************************************************************/
int get_ghost_num(void)
{
	char ghost[512];
	char kero[512];
	char path[1024];
	int hwnd;
	int cnt = 0;
	
	while( get_fmo(ghost,kero,&hwnd,path,cnt) == 0 )cnt++;
	
	return(cnt);
	
}

/************************************************************************/
/*			擾hWndFMOɂĎS[XgEP擾			*/
/************************************************************************/
int get_myname( void )
{
	char ghost[512];
	char kero[512];
	char path[1024];
	int hwnd_wrk;
	int loop_cnt;
	int ghost_num = get_ghost_num();
	
	if( *(GStrName[0].string) != '\0' )return(0);
	
	for( loop_cnt = 0; loop_cnt < ghost_num; loop_cnt++ ){
		get_fmo( ghost, kero, &hwnd_wrk, path, loop_cnt );
		if( hwnd_wrk == GHWnd ){
			strcpy( GStrName[0].string, ghost );
			strcpy( GStrName[1].string, kero );
		}
	}
	
	return(0);
}


/************************************************************************/
/*				w肳ꂽS[XghWnd擾						*/
/************************************************************************/
int get_hwnd_from_name( char* ghost )
{
	char wrk_ghost[512];
	char wrk_kero[512];
	char path[1024];
	int hwnd;
	int loop_cnt;
	int num = get_ghost_num();
	
	for( loop_cnt = 0; loop_cnt < num; loop_cnt++ ){
		if( get_fmo(wrk_ghost,wrk_kero,&hwnd,path,loop_cnt) != 0 ){
			hwnd = -1;
			break;
		}
		if( strcmp( wrk_ghost, ghost ) == 0 )break;
	}
	
	return(hwnd);
	
}


/************************************************************************/
/*				SS[Xgget_hwnds								*/
/************************************************************************/
int send_hwnd_to_allghost( void )
{
	COPYDATASTRUCT cds;
	char ghost[512];
	char kero[512];
	char path[1024];
	char sstp_str[1024];
	char wrk[130];
	int hwnd;
	int loop_cnt;
	int local_flg = 0;
	int num = get_ghost_num();
	
	/* SS[XgɌă[v */
	for( loop_cnt = 0; loop_cnt < num; loop_cnt++ ){
		/* eS[XghWnd擾i擾oȂ΃[vIj */
		if( get_fmo(ghost,kero,&hwnd,path,loop_cnt) != 0 )break;
		
		/* f[^GAZbg */
		strcpy( sstp_str, "NOTIFY SSTP/1.0\r\n" );
		strcat( sstp_str, "Sender: ESESHIORI\r\n" );
		strcat( sstp_str, "Event: EseGetHWnd\r\n" );
		sprintf( wrk, "Reference0: %d\r\n", hwnd );
		strcat( sstp_str, wrk );
		sprintf( wrk, "HWnd: %d\r\n", hwnd );
		strcat( sstp_str, wrk );
		strcat( sstp_str, "Charset: " ); 
		strcat( sstp_str, GStrDicCode ); 
		strcat( sstp_str, "\r\n\r\n" ); 
		
		cds.dwData = 9801;
		cds.cbData = strlen( sstp_str );
		cds.lpData = sstp_str;
		
		/* bZ[WMsȂ */
		SendMessage( (HWND)hwnd, WM_COPYDATA, NULL, (LPARAM) &cds );
		
		/* PłMtO𗧂Ă */
		local_flg = 1;
		
	}
	
	if( local_flg == 1 )HWND_FLG++;
	
	return(0);
	
}


/************************************************************************/
/*				gese-shiori[JȃCxg𔭍s			*/
/************************************************************************/
int send_eselocal_event( char* request )
{
	
	static int hour = -1;
	int loop_cnt;
	time_t ltime;
	tm* today;
	char wrk[1024];
	
	/* Ԏ擾 */
	time( &ltime );
	today = localtime( &ltime );
	
	/* ƃCxg */
	if( strstr( request, "Reference3: 0" ) != NULL ){
	}
	else{
		for( loop_cnt = 0; loop_cnt < GSelfEventNum; loop_cnt++ ){
			GSelfEvent[loop_cnt].timer--;
			if( GSelfEvent[loop_cnt].timer == 0 ){
				/* f[^Rs[č폜 */
				strcpy( wrk, GSelfEvent[loop_cnt].send_string );
				delete_self_event_data( loop_cnt );
				
				/* f[^M */
				COPYDATASTRUCT cds;
				cds.dwData = 9801;
				cds.cbData = strlen( wrk );
				cds.lpData = wrk;
				SendMessage( (HWND)GHWnd, WM_COPYDATA, NULL, (LPARAM) &cds );
			}
		}
	}
	
	/* _g[NCxg */
	if( strstr( request, "Reference3: 0" ) != NULL ){
	}
	else{
		GRandomTalkCount--;
	}
	if( GRandomTalkCount == 0 ){
		/* JE^ */
		GRandomTalkCount = GRandomTalkCountMax;
		/* Cxgs */
		send_eselocal_event_sub( "OnRandomTalk" );
		/* _g[Ns̓j[X⎞Ԍo߃Cxg͔sȂ */
		return(0);
	}
	
	/* j[Xg[NCxg */
	if( strstr( request, "Reference3: 0" ) != NULL );
	else GNewsReadCount--;
	if( GNewsReadCount == 0 ){
		/* JE^ */
		GNewsReadCount = GNewsReadCountMax;
		/* Cxgs */
		send_eselocal_event_sub( "OnNewsRead" );
		/* j[XCxgs͎Ԍo߃Cxg͔sȂ */
		return(0);
	}
	
	/* Ԍo߃Cxg */
	if( today->tm_hour != hour && today->tm_min == 0 ){
		/* Cxgs */
		send_eselocal_event_sub( "OnHourChange" );
		
		/* ݂́uԁvL */
		hour = today->tm_hour;
	}
	
	return(0);
	
}


/************************************************************************/
/*			ƃCxgf[^̍폜iJyёOl߁j			*/
/************************************************************************/
int delete_self_event_data( int del_no )
{
	int loop_cnt;
	
	/* J */
	free( GSelfEvent[del_no].send_string );
	
	/* Ol */
	for( loop_cnt = del_no; loop_cnt < GSelfEventNum-1; loop_cnt++ ){
		memcpy( (char*)&GSelfEvent[loop_cnt], (char*)&GSelfEvent[loop_cnt+1], sizeof(StrSelfEvent) );
	}
	
	/* f[^炷 */
	GSelfEventNum--;
	
	return(0);
	
}


/************************************************************************/
/*				gɃCxg𔭍siRefeiVj					*/
/************************************************************************/
int send_eselocal_event_sub( char* event_str )
{

	COPYDATASTRUCT cds;
	char wrk[130];
	char sstp_str[512];
	
	/* f[^GAZbg */
	if( GHWnd != -1 ){
		strcpy( sstp_str, "NOTIFY SSTP/1.0\r\n" );
		strcat( sstp_str, "Sender: ESESHIORI\r\n" );
		sprintf( wrk, "Event: %s\r\n", event_str );
		strcat( sstp_str, wrk );
		sprintf( wrk, "HWnd: %d\r\n", GHWnd );
		strcat( sstp_str, wrk );
		strcat( sstp_str, "Charset: " ); 
		strcat( sstp_str, GStrDicCode ); 
		strcat( sstp_str, "\r\n\r\n" ); 
		
		cds.dwData = 9801;
		cds.cbData = strlen( sstp_str );
		cds.lpData = sstp_str;
		
		/* bZ[WMsȂ */
		SendMessage( (HWND)GHWnd, WM_COPYDATA, NULL, (LPARAM) &cds );
		
	}
	
	return(0);
	
}


/************************************************************************/
/* 			NGXg̉͂sȂ									*/
/************************************************************************/
int chk_shiori20_request( char* buf )
{
	
	char* p_nowline;
	
	/* ʂɁAOnSecondChange͍ŏɃ`FbN */
	if( strstr( buf, "\r\nEvent: OnSecondChange" ) != 0 ){
		return(REQ_RESPONSE_EVENT_SECOND);
	}
	
	/* hWnd擾pCxg`FbN */
	if( strstr( buf, "\r\nEvent: EseGetHWnd" ) != 0 ){
		return(REQ_GET_HWND);
	}
	
	/* NGXge؂蕪 */
	if( memlcmp( buf, "GET Sentence" ) == 0 ){
		p_nowline = get_request_line_from_no( buf, 1 );
		/* ͊֌W */
		if( strstr( p_nowline, "Event: OnRandomTalk"    ) != NULL )return(REQ_AI_RANDOM);//ƒ
		if( strstr( p_nowline, "Event: EseSystemComTalk"    ) != NULL )return(REQ_AI_COMM);//b
		if( strstr( p_nowline, "Event: OnChoiceSelect"    ) != NULL )return(REQ_RESPONSE_EVENT_CHOICE);
																						//Ip
		if( strstr( p_nowline, "Event"    ) != NULL )return(REQ_RESPONSE_EVENT);
//		if( strstr( p_nowline, "Word"     ) != NULL )return(REQ_AI_TARGETWORD);
		if( strstr( p_nowline, "Word"     ) != NULL )return(REQ_RESPONSE_EVENT_WORD);
		if( strstr( p_nowline, "Sentence" ) != NULL )return(REQ_RESPONSE);
		
		return(REQ_RESPONSE_EVENT);
		
	}
	if( memlcmp( buf, "GET Word" ) == 0 ){
		/* ֌W */
		p_nowline = get_request_line_from_no( buf, 1 );
		if( p_nowline == NULL )                    return(-6);
//		if( strstr( p_nowline, "Type"     ) != NULL )return(REQ_WORD);
//		if( strstr( p_nowline, "Sentence" ) != NULL )return(REQ_MATCHWORD);
		if( strstr( p_nowline, "Type"     ) != NULL )return(REQ_RESPONSE_EVENT_WORD);
		if( strstr( p_nowline, "Sentence" ) != NULL )return(REQ_RESPONSE_EVENT);
		return(-7);
		
	}
	if( memlcmp( buf, "COMMUNICATE Sentence" ) == 0 ){
		/* COMMUNICATE֌W */
		p_nowline = get_request_line_from_no( buf, 1 );
		if( p_nowline == NULL )                    return(-8);
		if( strstr( p_nowline, "Sentence" ) != NULL )return(REQ_RESPONSE);
		
		return(-8);
		
	}
	if( memlcmp( buf, "NOTIFY"      ) == 0 )return(REQ_NOTIFY);
	if( memlcmp( buf, "GET Version" ) == 0 )return(REQ_GETVER);
	if( memlcmp( buf, "GET Status"  ) == 0 )return(REQ_AI_STATUS);
	if( memlcmp( buf, "GET String"  ) == 0 )return(REQ_SIMPLE_STRING);
	if( memlcmp( buf, "TEST"        ) == 0 )return(REQ_TEST);
/*	if( memlcmp( buf, "TRANSLATE"   ) == 0 )return(REQ_TRANSLATE);*/
	
	/* uāvNGXg̓CxgNGXgƉ */
	if( memlcmp( buf, "TEACH"       ) == 0 )return(REQ_RESPONSE_EVENT);
	
	return(-9);
	
}


/************************************************************************/
/* 			NGXg̉͂sȂ									*/
/************************************************************************/
int chk_shiori30_request( char* buf )
{
	
	/* SHIORI/3.0ł͂ȂNGXg̓`FbNȂ */
	if( strstr( buf, "SHIORI/3.0" ) == NULL )return(-1);
	
	/* ʂɁAOnSecondChange͍ŏɃ`FbN */
	if( strstr( buf, "ID: OnSecondChange" ) != NULL )return(REQ_SHIORI30_SECOND);
	
	/* Translate͖204^[ */
	if( strstr( buf, "ID: OnTranslate" ) != NULL )     return(REQ_TRANSLATE30);
	if( strstr( buf, "TRANSLATE SHIORI/3.0" ) != NULL )return(REQ_TRANSLATE30);
	
	/* NGXge؂蕪 */
	if( strstr( buf, "ID: version" ) != NULL ) return(REQ_GETVER30);
	if( strstr( buf, "ID: craftman" ) != NULL )return(REQ_GETVER30);
	if( strstr( buf, "ID: name" ) != NULL )    return(REQ_GETVER30);
	
	if( strstr( buf, "ID: hwnd" ) != NULL )              return(REQ_NOTIFY30);
	if( strstr( buf, "ID: uniqueid" ) != NULL )          return(REQ_NOTIFY30);
	if( strstr( buf, "ID: ownerghostname" ) != NULL )    return(REQ_NOTIFY30);
	if( strstr( buf, "ID: otherghostname" ) != NULL )    return(REQ_NOTIFY30);
	if( strstr( buf, "ID: installedghostname" ) != NULL )return(REQ_NOTIFY30);
	
	if( strstr( buf, "ID: OnChoiceSelect" ) != NULL )  return(REQ_SHIORI30_CHOICE);
	if( strstr( buf, "ID: OnRandomTalk" ) != NULL )    return(REQ_SHIORI30_RANDOM);
	if( strstr( buf, "ID: OnCommunicate" ) != NULL )   return(REQ_SHIORI30_COMM);
	if( strstr( buf, "ID: EseSystemComTalk" ) != NULL )return(REQ_AI_COMM30);
	if( strstr( buf, "ID: On" ) != NULL )              return(REQ_SHIORI30_EVENT);
	
	
	return(REQ_SHIORI30);
	
}


/************************************************************************/
/* 			NOTIFY擾											*/
/************************************************************************/
int request_get_notify( char* buf )
{
	
	char wrk[1030];
	char* p_wrk;
	char* p_nowline;
	int loop_cnt;
	int len;
	int len2 = strlen("Ghost: ");
	int len3 = strlen("GhostEx: ");
	
	/* S[Xg擾H */
	if( memlcmp( buf, "NOTIFY OwnerGhostName SHIORI/2." ) == 0 ){
		p_nowline = get_request_line_from_no( buf, 2 );
		if( p_nowline == NULL )return(-1);
		if( memlcmp( p_nowline, "Ghost: " ) != 0 )return(-1);
		
		p_wrk = strchr( p_nowline, '\r' );
		if( p_wrk == NULL )return(-1);
		*p_wrk = '\0';
		strncpy( GGhostName, p_nowline+len2, 128 );
		GGhostName[128] = '\0';
	}
	/* S[Xg擾H */
	else if( memlcmp( buf, "NOTIFY OtherGhostName SHIORI/2." ) == 0 ){
		/* ŏɗ̈揉 */
		for( loop_cnt = 0; loop_cnt < GHOST_NUM; loop_cnt++ ){
			if( GOtherGhostName[loop_cnt] != NULL ){
				free( GOtherGhostName[loop_cnt] );
			}
		}
		
		/* S[Xg擾{S[XglZo */
		GOtherGhostNum = 0;
		for( loop_cnt = 0; loop_cnt < GHOST_NUM; loop_cnt++ ){
			
			p_nowline = get_request_line_from_no( buf, loop_cnt+1 );
			if( p_nowline != NULL ){
				/* O؂o */
				p_wrk = strchr( p_nowline, '\r' );
				if( p_wrk == NULL )continue;
				if( memlcmp( p_nowline, "GhostEx: " ) != 0 ){
					continue;
				}
				
				/* "GhostEx"t̂ŖOǉ{l */
				len = p_wrk - p_nowline - len3;
				if( len > 1024 )len = 1024;
				memcpy( wrk, p_nowline+len3, len );
				wrk[len] = '\0';
				p_wrk = strchr( wrk, 0x01 );
				if( p_wrk != NULL )*p_wrk = '\0';
				len = strlen(wrk);
				
				/* GAm */
				p_wrk = (char*)malloc( len+1 );
				if( p_wrk == NULL )break;
				
				/* GAɃRs[ċL */
				strcpy( p_wrk, wrk );
				GOtherGhostName[GOtherGhostNum] = p_wrk;
				
				/* lǉ */
				GOtherGhostNum++;
			}
			else{
				break;
			}
			
		}
	}
	
	strcpy( buf, "SHIORI/2.0 200 OK\r\n\r\n" );
	
	return(0);
	
}


/************************************************************************/
/* 			NOTIFY̊e擾								*/
/************************************************************************/
int request_get_notify30( char* buf )
{
	
	char wrk[1030];
	char* p_wrk;
	char* p_wrk2;
	char* p_nowline;
	int loop_cnt;
	int len;
	int hwnd_saku;
	int hwnd_kero;
	int hwnd_saku_b;
	int hwnd_kero_b;
	
	/* S[Xg擾H */
	if( strstr( buf, "ID: ownerghostname" ) != NULL ){
		/* 芸Ȃ */
	}
	/* S[Xg擾H */
	else if( strstr( buf, "ID: otherghostname" ) != NULL ){
		/* ŏɗ̈揉 */
		for( loop_cnt = 0; loop_cnt < GHOST_NUM; loop_cnt++ ){
			if( GOtherGhostName[loop_cnt] != NULL ){
				free( GOtherGhostName[loop_cnt] );
			}
		}
		
		/* S[Xg擾{S[XglZo */
		GOtherGhostNum = 0;
		for( loop_cnt = 0; loop_cnt < GHOST_NUM; loop_cnt++ ){
			
			p_nowline = get_request_line_from_no( buf, loop_cnt+1 );
			if( p_nowline != NULL ){
				/* O؂o */
				if( memlcmp( p_nowline, "Reference" ) != 0 ){
					continue;
				}
				p_wrk = strchr( p_nowline, '\1' );
				if( p_wrk == NULL )continue;
				p_wrk2 = strchr( p_nowline, ':' );
				if( p_wrk2 == NULL )continue;
				
				/* Ghostt̂ŖOǉ */
				len = p_wrk - p_wrk2 - 2;
				if( len > 1024 )len = 1024;
				memcpy( wrk, p_wrk2+2, len );
				wrk[len] = '\0';
				len = strlen(wrk);
				
				/* GAm */
				p_wrk = (char*)malloc( len+1 );
				if( p_wrk == NULL )break;
				
				/* GAɃRs[ċL */
				strcpy( p_wrk, wrk );
				GOtherGhostName[GOtherGhostNum] = p_wrk;
				
				/* lǉ */
				GOtherGhostNum++;
			}
			else{
				break;
			}
		}
	}
	/* hWnd擾H */
	else if( strstr( buf, "ID: hwnd" ) != NULL ){
		/* hWnd擾 */
		p_wrk = strstr( buf, "Reference0: " );
		if( p_wrk != NULL ){
			if( sscanf( p_wrk, "Reference0: %d\1%d", &hwnd_saku, &hwnd_kero ) == 2 ){
				GHWnd = hwnd_saku;
				sprintf( GStrName[2].string, "%d", hwnd_saku );
				sprintf( GStrName[3].string, "%d", hwnd_kero );
			}
			else{
				GHWnd = -1;
			}
		}
		
		p_wrk = strstr( buf, "Reference1: " );
		if( p_wrk != NULL ){
			if( sscanf( p_wrk, "Reference1: %d\1%d", &hwnd_saku_b, &hwnd_kero_b ) == 2 ){
				sprintf( GStrName[4].string, "%d", hwnd_saku_b );
				sprintf( GStrName[5].string, "%d", hwnd_kero_b );
			}
		}
		
		/* MtO𗧂ĂiO擾Ȃj */
		HWND_FLG = 99;
		
	}
	
	strcpy( buf, "SHIORI/3.0 200 OK\r\n\r\n" );
	
	return(0);
	
}


/************************************************************************/
/* 			o[W擾iSHIORI2.xxpj								*/
/************************************************************************/
int request_get_ver( char* buf )
{
	
	strcpy( buf, "SHIORI/2.5 200 OK\r\n" );
	strcat( buf, "ID: " ESE_SHIORI_NAME "\r\n" );
	strcat( buf, "Craftman: " ESE_SHIORI_CREATOR "\r\n" );
	strcat( buf, "Version: " ESE_SHIORI_VERSION "\r\n" );
	strcat( buf, "Charset: " );
	strcat( buf, GStrDicCode ); 
	strcat( buf, "\r\n\r\n" );
	
	return(0);
	
}


/************************************************************************/
/* 			o[W擾iSHIORI/3.0pj								*/
/************************************************************************/
int request_get_ver30( char* buf )
{
	
	if( strstr( buf, "ID: version" ) != NULL ){
		strcpy( buf, "SHIORI/3.0 200 OK\r\n" );
		strcat( buf, "Value: " ESE_SHIORI_VERSION "\r\n" );
		strcat( buf, GStrDicCode ); 
		strcat( buf, "\r\n\r\n" );
	}
	else if( strstr( buf, "ID: craftman" ) != NULL ){
		strcpy( buf, "SHIORI/3.0 200 OK\r\n" );
		strcat( buf, "Value: " ESE_SHIORI_CREATOR "\r\n" );
		strcat( buf, GStrDicCode ); 
		strcat( buf, "\r\n\r\n" );
	}
	else if( strstr( buf, "ID: name" ) != NULL ){
		strcpy( buf, "SHIORI/3.0 200 OK\r\n" );
		strcat( buf, "Value: " ESE_SHIORI_NAME "\r\n" );
		strcat( buf, GStrDicCode ); 
		strcat( buf, "\r\n\r\n" );
	}
	
	return(0);
	
}


/************************************************************************/
/* 			`h擾ieڂ̓[U[w肷j					*/
/*		iƂTO̓iCƂɂ͍Ȃj	*/
/************************************************************************/
int request_get_ai_status( char* buf )
{
	
	int neuron = get_entry_num( GNeuron );
	int neuronM = get_entry_num( GNeuronM );
	int neuronK = get_entry_num( GNeuronK );
	int neuronD = get_entry_num( GNeuronD );
	int neuronE = get_entry_num( GNeuronE );
	int synapses = get_entry_num( GSynapses );
	int u_neuron =   neuron   + get_learning_data( GNeuron );
	int u_neuronM =  neuronM  + get_learning_data( GNeuronM );
	int u_neuronK =  neuronK  + get_learning_data( GNeuronK );
	int u_neuronD =  neuronD  + get_learning_data( GNeuronD );
	int u_neuronE =  neuronE  + get_learning_data( GNeuronE );
	int u_synapses = synapses + get_learning_data( GSynapses );
	
	sprintf( buf, "SHIORI/2.0 200 OK\r\nStatus: %d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d\r\n\r\n",
			neuron,neuronM,neuronK,neuronD,neuronE,synapses,
			u_neuron,u_neuronM,u_neuronK,u_neuronD,u_neuronE,u_synapses );
	
	return(0);
	
}


/************************************************************************/
/* 			wKf[^ł̎wGgf[^擾					*/
/************************************************************************/
int get_learning_data( char* entry )
{
	FILE* fp;
	char wrk[1030];
	int flg;
	int cnt;
	
	/* wKt@CI[v */
	/* it@CΑΏۃGgOƂă^[j */
	fp = fopen( GUserDicFile, "rt" );
	if( fp == NULL )return(0);
	
	/* SĂ̍sɂĒ */
	flg = 0;
	cnt = 0;
	while( fgets( wrk, 1024, fp ) != NULL ){
		/* Ggs̏ */
		if( wrk[0] == '#' ){
			if( memlcmp( &wrk[1], entry ) == 0 )flg = 1;
			else								flg = 0;
			continue;
		}
		
		/* RgsOsq */
		if( memlcmp( wrk, "//" ) == 0 )continue;
		if( wrk[0] == '\n' )continue;
		if( memlcmp( wrk, "$ELSEIF" ) == 0 )continue;
		if( memlcmp( wrk, "$ELSE" ) == 0 )continue;
		if( memlcmp( wrk, "$ENDIF" ) == 0 )continue;
		if( memlcmp( wrk, "$_ELSEIF" ) == 0 )continue;
		if( memlcmp( wrk, "$_ELSE" ) == 0 )continue;
		if( memlcmp( wrk, "$_ENDIF" ) == 0 )continue;
		if( memlcmp( wrk, "$__ELSEIF" ) == 0 )continue;
		if( memlcmp( wrk, "$__ELSE" ) == 0 )continue;
		if( memlcmp( wrk, "$__ENDIF" ) == 0 )continue;
		if( wrk[0] == 0x09 )continue;
		
		/* Yf[^sȂJEg */
		cnt += flg;
		
	}
	
	fclose(fp);
	
	return(cnt);
	
}


/************************************************************************/
/* 			ʏ풝蕶쐬iNGXgpj								*/
/************************************************************************/
int request_get_ai_talk( char* buf )
{
	
	char* wrk;
	
	/* ď */
	set_rand();
	
	/* Ɨ̈m */
	wrk = (char*)malloc(LINE_BUF_SIZE);
	if( wrk == NULL ){
		/* ̈悪mۏoȂ̂ŒȂ */
		strcpy( buf, "SHIORI/2.0 204 No Content\r\n\r\n" );
		return(0);
	}
	
	/* ʏ풝胍OoiMj */
	log_write_user( "-----------------------------------------------", "ese_talk.log", GTalkLog );
	log_write_user( buf, "ese_talk.log", GTalkLog );
	
	/* {쐬 */
	GTalkLogLocal = GTalkLog;
	aitalk_comm( buf, wrk );
	GTalkLogLocal = 0;
	
	/* wb_쐬 */
	make_target_header( buf, wrk, 200 );
	
	/* ʏ풝胍OoiMj */
	log_write_user( buf, "ese_talk.log", GTalkLog );
	
	/* Ɨ̈J */
	free(wrk);
	
	return(0);
	
}


/************************************************************************/
/* 			ʏ풝蕶쐬iNGXgpj								*/
/************************************************************************/
int request_get_ai_talk30( char* buf )
{
	
	char* wrk;
	
	/* ď */
	set_rand();
	
	/* Ɨ̈m */
	wrk = (char*)malloc(LINE_BUF_SIZE);
	if( wrk == NULL ){
		/* ̈悪mۏoȂ̂ŒȂ */
		strcpy( buf, "SHIORI/3.0 204 No Content\r\n\r\n" );
		return(0);
	}
	
	/* ʏ풝胍OoiMj */
	log_write_user( "-----------------------------------------------", "ese_talk.log", GTalkLog );
	log_write_user( buf, "ese_talk.log", GTalkLog );
	
	/* {쐬 */
	GTalkLogLocal = GTalkLog;
	aitalk_comm( buf, wrk );
	GTalkLogLocal = 0;
	
	/* wb_쐬 */
	make_target_header30( buf, wrk, 200 );
	
	/* ʏ풝胍OoiMj */
	log_write_user( buf, "ese_talk.log", GTalkLog );
	
	/* Ɨ̈J */
	free(wrk);
	
	return(0);
	
}


/************************************************************************/
/*				b^`hg[N									*/
/************************************************************************/
int aitalk_comm( char* request, char* buf )
{
	
	char wrk[64];
	char* input;
	char* output;
	static int char_flg;
	int char_flg_wrk;
	int talk_cnt;
	int loop_cnt;
	int err_cnt;
	
	/* o̓obt@ */
	*buf = '\0';
	
	/* ͗pƗ̈m */
	input = (char*)malloc(LINE_BUF_SIZE);
	if( input == NULL ){
		/* ̈悪mۏoȂ̂ŒȂ */
		strcpy( buf, "SHIORI/2.0 204 No Content\r\n\r\n" );
		return(0);
	}
	
	/* Ɨ̈m */
	output = (char*)malloc(LINE_BUF_SIZE);
	if( output == NULL ){
		/* ̈悪mۏoȂ̂ŒȂ */
		free( input );
		strcpy( buf, "SHIORI/2.0 204 No Content\r\n\r\n" );
		return(0);
	}
	
	/* bX^[gL߂ */
	if( strstr( request, "start=sakura" ) != NULL )char_flg = CHAR_SAKURA;
	else if( strstr( request, "start=kero" ) != NULL )char_flg = CHAR_KERO;
	else{
		char_flg = ( char_flg == CHAR_SAKURA ? CHAR_SAKURA : CHAR_KERO );
	}
	char_flg_wrk = char_flg;
	
	/* JnL[[hZbg */
	strcpy( input, "bX^[g" );
	
	/* bI܂Ń[v */
	for( talk_cnt = 1;; talk_cnt++ ){
		
		/* Ageyу[U[tt */
		sprintf( wrk, ",Age=%d", talk_cnt );
		strcat( input, wrk );
		for( loop_cnt = PUSH_E_UPHASE_START_NO; loop_cnt < PUSH_E_UPHASE_END_NO; loop_cnt++ ){
			if( GStack[loop_cnt] != NULL ){
				sprintf( wrk, ",INFO%d=", loop_cnt-PUSH_E_UPHASE_START_NO+1 );
				strcat( input, wrk );
				strcat( input, GStack[loop_cnt] );
			}
		}
		
		/* LZbg */
		change_other_dic(char_flg);
		
		/* X|XOoíj */
		log_write_user( "-----------------------------------------------", "ese_talk.log", GTalkLogLocal );
		log_write_user( input, "ese_talk.log", GTalkLogLocal );
		
		/* P쐬igCvŃgCj */
		for(err_cnt=0;err_cnt<99;err_cnt++){
			get_response( input, output );
			if( strstr( output, "$COMTALK_RETRY1" ) == NULL )break;
			if( strstr( output, "$COMTALK_RETRY0" ) != NULL ){
				char_flg = char_flg_wrk;
				strcpy( input, "bX^[g" );
				talk_cnt = 0;
				log_write_user( "	----S蒼----", "ese_talk.log", GTalkLogLocal );
				break;
			}
			log_write_user( "	----P蒼----", "ese_talk.log", GTalkLogLocal );
		}
		if( talk_cnt == 0 ){
			talk_cnt++;
			continue;
		}
		
		/* X|XOoiój */
		log_write_user( output, "ese_talk.log", GTalkLogLocal );
		
		/* bo̓obt@ɃZbg */
		if( char_flg == CHAR_SAKURA ){
			strcat( buf, "\\0" );
			strcat( buf, output );
			strcat( buf, "\\n\\w8" );
			char_flg = CHAR_KERO;
		}
		else{
			strcat( buf, "\\1" );
			strcat( buf, output );
			strcat( buf, "\\n\\w8" );
			char_flg = CHAR_SAKURA;
		}
		
		/* output'\e'ΉbI */
		if( strstr( output, "\\e" ) != NULL )break;
		
		/* bȏꍇ͖Ő؂ */
		if( talk_cnt > 10 ){
			strcat( buf, "\\e" );
			break;
		}
		
		/* bp̏ꍇ͍̏o͂̓͂փRs[ */
		strcpy( input, output );
		
	}
	
	/* Ɨ̈J */
	free( input );
	free( output );
	
	/* ftHgɖ߂ */
	change_other_dic(0);
	
	/* bIiʏ̏IR[hƂj */
	return(200);
	
}


/************************************************************************/
/*		ԓԂ														*/
/************************************************************************/
int request_get_response( char* buf )
{
	
	char* wrk;
	int loop_cnt;
	
	/* ď */
	set_rand();
	
	/* Ɨ̈m */
	wrk = (char*)malloc(LINE_BUF_SIZE);
	if( wrk == NULL ){
		/* ̈悪mۏoȂ̂ŒȂ */
		strcpy( buf, "SHIORI/2.0 204 No Content\r\n\r\n" );
		return(0);
	}
	
	/* SHIORI/2.2\r\nʂ̕i[??]ƌ`jɒu */
	change_cntchr_to_ascstr( buf );
	
	/* Reference??ŗL^OɎ[ */
	refe_to_orgtag( buf );
	
	/* [U[tt */
	for( loop_cnt = PUSH_E_UPHASE_START_NO; loop_cnt < PUSH_E_UPHASE_END_NO; loop_cnt++ ){
		if( GStack[loop_cnt] != NULL ){
			sprintf( wrk, ",INFO%d=", loop_cnt-PUSH_E_UPHASE_START_NO+1 );
			strcat( buf, wrk );
			strcat( buf, GStack[loop_cnt] );
		}
	}
	strcat( buf, "\n" );
	
	/* X|XOoiMj */
	log_write_user( "-----------------------------------------------", "ese_response.log", GResponseLog );
	log_write_user( buf, "ese_response.log", GResponseLog );
	
	/* {쐬 */
	int header_code = get_response( buf, wrk );
	
	/* wb_쐬 */
	make_target_header( buf, wrk, header_code );
	
	/* X|XOoiMj */
	log_write_user( buf, "ese_response.log", GResponseLog );
	
	/* Ɨ̈J */
	free(wrk);
	
	return(0);
	
}


/************************************************************************/
/*		Cxg												*/
/************************************************************************/
int request_get_event( char* buf, int type )
{
	static time_t last_talk_time = (time_t)0;
	time_t ltime;
	static long ghost_state = 0;
	long ret = 0;
	char choice_entry[130];
	char* wrk;
	char* p_wrk;
	int loop_cnt;
	int local_log_flg = 1;				//ftHgĺuov
log_write_user( "---------------------------------------------------------------", "ese_event.log", GEventLog*local_log_flg );
log_write_user( buf, "ese_event.log", GEventLog*local_log_flg );
	
	/* ݎԂ擾 */
	time( &ltime );
	
	/* {̂̒Ԃ擾 */
	if( GHWnd != -1 ){
		unsigned int wm_sakuraapi = RegisterWindowMessage("Sakura");
		ret = (LRESULT)SendMessage( (HWND)GHWnd, wm_sakuraapi, 140, NULL );
	}
	else{
	}
	
	if( ghost_state != 0 && ret == 0 ){
		/* ʂ̒肪IgRȂ̂ŁAݎԂoĂ */
		last_talk_time = ltime;
	}
	ghost_state = ret;
	
	/* ubNw肳ꂽCxgHiWORD擾͊֌Wj */
	if( strstrs( buf, GStrTalkBlockEvent ) != NULL && type != REQ_RESPONSE_EVENT_WORD ){
		/* 蒆Ȃ̂ŃCxgsȂ */
		if( ret != 0 ){
log_write_user( "-----------------block Talk--------------------", "ese_event.log", GEventLog*local_log_flg );
log_write_user( buf, "ese_event.log", GEventLog*local_log_flg );
			/* QOSwb_쐬 */
			strcpy( buf, "SHIORI/2.0 204 No Content\r\n\r\n" );
			return(2);
		}
		
		/* wbo߂ĂȂ̂ŃCxgsȂ */
		if( last_talk_time + GTalkAfterInterval > ltime ){
log_write_user( "-----------------block Time--------------------", "ese_event.log", GEventLog*local_log_flg );
log_write_user( buf, "ese_event.log", GEventLog*local_log_flg );
			/* QOSwb_쐬 */
			strcpy( buf, "SHIORI/2.0 204 No Content\r\n\r\n" );
			return(2);
		}
		
	}
	
	/* Oo۔ */
	if( GEventLog == 1 ){
		/* ֎~[huoȂv */
		if( strstrs( buf, GStrNotWriteEvent ) != NULL )local_log_flg = 0;
	}
	
	/* ď */
	set_rand();
	
	/* ԏ擾 */
	tm* today;
	today = localtime( &ltime );
	
	/* SHIORI/2.2\r\nʂ̕i[??]ƌ`jɒu */
	change_cntchr_to_ascstr( buf );
	
	/* Reference??ŗL^OɎ[ */
	refe_to_orgtag( buf );
	
	/* Ɨ̈m */
	wrk = (char*)malloc(LINE_BUF_SIZE);
	if( wrk == NULL ){
		/* ̈悪mۏoȂ̂ŒȂ */
		strcpy( buf, "SHIORI/2.0 204 No Content\r\n\r\n" );
		return(1);
	}
	
	/* ͕Ƀ[ht */
	sprintf( wrk, "MODE=%s,", GRndEntry );
	strcat( buf, wrk );
	
	/* ͕Ɏԏti^Cvɂt͈قȂj */
	if( GStrDicCodeOld == DIC_TYPE_1xx ){
		strftime( wrk, 1024, "=%Y,=%m,=%d,=%H,=%M,b=%S,j=%A---TIMEEND", today );
	}
	else{
		strftime( wrk, 1024, "YEAR=%Y,MONTH=%m,DAY=%d,HOUR=%H,MINUTE=%M,SECOND=%S,DAYOFWEEK=%A---TIMEEND", today );
	}
	strcat( buf, wrk );
	
	/* [U[tt */
	for( loop_cnt = PUSH_E_UPHASE_START_NO; loop_cnt < PUSH_E_UPHASE_END_NO; loop_cnt++ ){
		if( GStack[loop_cnt] != NULL ){
			sprintf( wrk, ",INFO%d=", loop_cnt-PUSH_E_UPHASE_START_NO+1 );
			strcat( buf, wrk );
			strcat( buf, GStack[loop_cnt] );
		}
	}
	strcat( buf, "\n" );
	
	/* "OnChoice"̏ꍇRef0̒gőPQWoCg܂Ŏ擾Ă */
	if( type == REQ_RESPONSE_EVENT_CHOICE ){
		p_wrk = strstr( buf, "Reference0: #" );
		if( p_wrk != NULL )memcpy( choice_entry, p_wrk+13, 128 );
		p_wrk = strstr( choice_entry, "[13]" );
		if( p_wrk != NULL ){
			*p_wrk = '\0';
			*(p_wrk+1) = '\0';
			*(p_wrk+2) = '\0';
			*(p_wrk+3) = '\0';
		}
		choice_entry[128] = '\0';
	}
	
	/* CxgOoiMj */
	log_write_user( "-----------------------------------------------", "ese_event.log", GEventLog*local_log_flg );
	log_write_user( buf, "ese_event.log", GEventLog*local_log_flg );
	
	/* {쐬 */
	int header_code = get_event_res( buf, wrk );
	
	/* 204iYGgjŁA"OnChoice"̏ꍇ͓ʏ */
	if( header_code == 204 && type == REQ_RESPONSE_EVENT_CHOICE ){
		get_rnd_sentence( choice_entry, wrk );
		if( strstr( wrk, "ESESHIORI ERROR" ) == NULL )header_code = 200;
	}
	/* 204iYGgjŁA"OnRandomTalk"̏ꍇ͋݊ */
	if( header_code == 204 && type == REQ_AI_RANDOM ){
		strcpy( wrk, "sr1" );
		get_rnd_sentence( wrk, wrk );
		if( strstr( wrk, "ESESHIORI ERROR" ) == NULL )header_code = 200;
	}
	
	/* wb_쐬 */
	if( type == REQ_RESPONSE_EVENT_WORD ){
		make_target_header_word( buf, wrk, header_code );
	}
	else{
		make_target_header( buf, wrk, header_code );
	}
	
	/* ⓚpŒԂƂ */
	if( header_code != 204 )ghost_state = 1;
	
	/* CxgOoiMj */
	log_write_user( buf, "ese_event.log", GEventLog*local_log_flg );
	
	/* Ɨ̈J */
	free(wrk);
	
	return(0);
	
}


/************************************************************************/
/*		PԂ												*/
/************************************************************************/
int request_get_simple_string( char* buf )
{
	
	char* wrk;
	
	/* ď */
	set_rand();
	
	/* Ɨ̈m */
	wrk = (char*)malloc(LINE_BUF_SIZE);
	if( wrk == NULL ){
		/* ̈悪mۏoȂ̂ŒȂ */
		strcpy( buf, "SHIORI/2.0 204 No Content\r\n\r\n" );
		return(0);
	}
	
	/* 擾OoiMj */
	log_write_user( "-----------------------------------------------", "ese_string.log", GStringLog );
	log_write_user( buf, "ese_string.log", GStringLog );
	
	/* {쐬 */
	int header_code = get_simple_string( buf, wrk );
	
	/* wb_쐬 */
	if( header_code == 204 ){
		strcpy( buf, "SHIORI/2.0 204 No Content\r\n\r\n" );
	}
	else{
		strcpy( buf, "SHIORI/2.5 200 OK\r\nString: " );
		strcat( buf, wrk );
		strcat( buf, "\r\nCharset: " );
		strcat( buf, GStrDicCode ); 
		strcat( buf, "\r\n\r\n" ); 
	}
	
	/* 擾OoiMj */
	log_write_user( buf, "ese_string.log", GStringLog );
	
	/* Ɨ̈J */
	free(wrk);
	
	return(0);
	
}


/************************************************************************/
/*						eXgNGXgp								*/
/************************************************************************/
int request_test( char* buf )
{

	
	char wrk[512];
	if( get_ghost_num() > 1 ){
		strcpy( wrk, "$GETGHOST(\"\",1,0)\\h\\s0[A$POP(1)`B\\e$REFLECT(POP(1))" );
		act_func( wrk, "", 0 );
		make_target_header( buf, wrk, 200 );
	}
	
	return(0);
	

}

/************************************************************************/
/*				hWnd擾ׁ̈AőoĎŎ󂯎				*/
/************************************************************************/
int request_get_hwnd( char* buf )
{
	char* p_wrk;
	
	/* hWnd擾 */
	p_wrk = strstr( buf, "Reference0: " );
	if( p_wrk != NULL ){
		if( sscanf( p_wrk, "Reference0: %d", &GHWnd ) == 0 )GHWnd = -1;
	}
	
	/* MtO𗧂Ă */
	HWND_FLG = 99;
	
	/*  */
	strcpy( buf, "SHIORI/2.0 204 No Content\r\n\r\n" );
	
	/* hWnd̂łɎS[XgEP擾 */
	char ghost[512];
	char kero[512];
	char path[1024];
	int hwnd_wrk;
	int loop_cnt;
	int ghost_num = get_ghost_num();
	for( loop_cnt = 0; loop_cnt < ghost_num; loop_cnt++ ){
		get_fmo( ghost, kero, &hwnd_wrk, path, loop_cnt );
		if( hwnd_wrk == GHWnd ){
			strcpy( GStrName[0].string, ghost );
			strcpy( GStrName[1].string, kero );
		}
	}
	
	return(0);
	
}


/************************************************************************/
/*								u								*/
/************************************************************************/
int request_translate( char* buf )
{
	
	strcpy( buf, "SHIORI/2.0 204 No Content\r\n\r\n" );
	
	return(0);
	
}


/************************************************************************/
/*								u								*/
/************************************************************************/
int request_translate30( char* buf )
{
	
	strcpy( buf, "SHIORI/3.0 204 No Content\r\n\r\n" );
	
	return(0);
	
}


/************************************************************************/
/*		SHIORI/3.0NGXg									*/
/************************************************************************/
int request_shiori30( char* buf, int type )
{
	static time_t last_talk_time = (time_t)0;
	time_t ltime;
	static long ghost_state = 0;
	long ret = 0;
	char choice_entry[130];
	char* wrk;
	char* p_wrk;
	int loop_cnt;
	int local_log_flg = 1;				//ftHgĺuov
	
	log_write_user( "---------------------------------------------------------------", "ese_request.log", GRequestLog*local_log_flg );
	log_write_user( buf, "ese_request.log", GRequestLog*local_log_flg );
	
	/* ݎԂ擾 */
	time( &ltime );
	
	/* {̂̒Ԃ擾 */
	if( GHWnd != -1 ){
		unsigned int wm_sakuraapi = RegisterWindowMessage("Sakura");
		ret = (LRESULT)SendMessage( (HWND)GHWnd, wm_sakuraapi, 140, NULL );
	}
	else{
	}
	
	if( ghost_state != 0 && ret == 0 ){
		/* ʂ̒肪IgRȂ̂ŁAݎԂoĂ */
		last_talk_time = ltime;
	}
	ghost_state = ret;
	
	/* ubNw肳ꂽCxgH */
	if( strstrs( buf, GStrTalkBlockEvent ) != NULL ){
		/* 蒆Ȃ̂ŃCxgsȂ */
		if( ret != 0 ){
			/* QOSwb_쐬 */
			strcpy( buf, "SHIORI/3.0 204 No Content\r\n\r\n" );
			return(2);
		}
		
		/* wbo߂ĂȂ̂ŃCxgsȂ */
		if( last_talk_time + GTalkAfterInterval > ltime ){
			/* QOSwb_쐬 */
			strcpy( buf, "SHIORI/3.0 204 No Content\r\n\r\n" );
			return(2);
		}
		
	}
	
	/* ď */
	set_rand();
	
	/* ԏ擾 */
	tm* today;
	today = localtime( &ltime );
	
	/* SHIORI/3.0\r\nʂ̕i[??]ƌ`jɒu */
	change_cntchr_to_ascstr( buf );
	
	/* Reference??ŗL^OɎ[ */
	refe_to_orgtag( buf );
	
	/* Ɨ̈m */
	wrk = (char*)malloc(LINE_BUF_SIZE);
	if( wrk == NULL ){
		/* ̈悪mۏoȂ̂ŒȂ */
		strcpy( buf, "SHIORI/3.0 204 No Content\r\n\r\n" );
		return(1);
	}
	
	/* ͕Ƀ[ht */
	sprintf( wrk, "MODE=%s,", GRndEntry );
	strcat( buf, wrk );
	
	/* ͕Ɏԏt */
	strftime( wrk, 1024, "YEAR=%Y,MONTH=%m,DAY=%d,HOUR=%H,MINUTE=%M,SECOND=%S,DAYOFWEEK=%A---TIMEEND", today );
	strcat( buf, wrk );
	
	/* [U[tt */
	for( loop_cnt = PUSH_E_UPHASE_START_NO; loop_cnt < PUSH_E_UPHASE_END_NO; loop_cnt++ ){
		if( GStack[loop_cnt] != NULL ){
			sprintf( wrk, ",INFO%d=", loop_cnt-PUSH_E_UPHASE_START_NO+1 );
			strcat( buf, wrk );
			strcat( buf, GStack[loop_cnt] );
		}
	}
	strcat( buf, "\n" );
	
	/* "OnChoice"̏ꍇRef0̒gőPQWoCg܂Ŏ擾Ă */
	if( type == REQ_SHIORI30_CHOICE ){
		p_wrk = strstr( buf, "Reference0: #" );
		if( p_wrk != NULL )memcpy( choice_entry, p_wrk+13, 128 );
		p_wrk = strstr( choice_entry, "[13]" );
		if( p_wrk != NULL ){
			*p_wrk = '\0';
			*(p_wrk+1) = '\0';
			*(p_wrk+2) = '\0';
			*(p_wrk+3) = '\0';
		}
		choice_entry[128] = '\0';
	}
	
	/* CxgOoiMj */
	log_write_user( "-----------------------------------------------", "ese_request.log", GRequestLog*local_log_flg );
	log_write_user( buf, "ese_request.log", GRequestLog*local_log_flg );
	
	/* {쐬 */
	int header_code = get_request_res( buf, wrk );
	
	/* 204iYGgj̏ꍇ */
	if( header_code == 204 ){
		/* ʏCxgnƎv */
		if( type == REQ_SHIORI30_EVENT  ||
			type == REQ_SHIORI30_SECOND ||
			type == REQ_SHIORI30_CHOICE ||
			type == REQ_SHIORI30_RANDOM   ){
			header_code = get_event_res( buf, wrk );
			if( header_code == 204 ){
				header_code = get_simple_string( buf, wrk );
			}
		}
		/* R~jP[gCxgn */
		else if( type == REQ_SHIORI30_COMM ){
			header_code = get_response( buf, wrk );
		}
		/* \[XnƎv */
		else{
			header_code = get_simple_string( buf, wrk );
			if( header_code == 204 ){
				header_code = get_event_res( buf, wrk );
			}
		}
	}
	
	/* 204iYGgjŁA"OnChoice"̏ꍇ͓ʏ */
	if( header_code == 204 && type == REQ_SHIORI30_CHOICE ){
		header_code = get_rnd_sentence( choice_entry, wrk );
	}
	/* 204iYGgjŁA"OnRandomTalk"̏ꍇ͋݊ */
	if( header_code == 204 && type == REQ_SHIORI30_RANDOM ){
		strcpy( wrk, "sr1" );
		header_code = get_rnd_sentence( wrk, wrk );
	}
	
	/* wb_쐬 */
	make_target_header30( buf, wrk, header_code );
	
	/* CxgOoiMj */
	log_write_user( buf, "ese_request.log", GRequestLog*local_log_flg );
	
	/* Ɨ̈J */
	free(wrk);
	
	return(0);
	
}


/************************************************************************/
/* 			Cӂ̍s擪Ɉړ										*/
/************************************************************************/
char* get_request_line_from_no( char* top_point, int line )
{
	char* p_wrk;
	char* now_point;
	
	/* Psڎw̏ꍇ͍s擪 */
	if( line == 0 )return(top_point);
	
	for( now_point = top_point; line > 0; line-- ){
		/* EOD`FbN */
		p_wrk = strstr( now_point, "\r\r\n\r\r\n" );
		if( p_wrk != NULL )return(NULL);
		p_wrk = strstr( now_point, "\r\r\n\r\r\n" );
		if( p_wrk != NULL )return(NULL);
		
		/* f~^`FbN */
		p_wrk = strstr( now_point, "\r\r\n" );
		if( p_wrk != NULL ){
			now_point = p_wrk+3;
			continue;
		}
		p_wrk = strstr( now_point, "\r\n" );
		if( p_wrk != NULL ){
			now_point = p_wrk+2;
			continue;
		}
		
		/* 擾sij */
		return(NULL);
		
	}
	
	return(now_point);
	
}

/************************************************************************/
/* 		Reference??̕ŗL^OɃZbg							*/
/************************************************************************/
int refe_to_orgtag( char* buf )
{
	char ref_wrk[48];
	char* p_wrk;
	char* p_saki;
	int loop_cnt;
	int len;
	
	/* "Reference0"`"Reference7"`FbN */
	for( loop_cnt = 0; loop_cnt < 8; loop_cnt++ ){
		sprintf( ref_wrk, "[13][10]Reference%d: ", loop_cnt );
		len = strlen(ref_wrk);
		
		/* ꍇ͋LAOoCg */
		p_saki = GStrName[loop_cnt+6].string;
		if( p_saki == NULL )continue;
		
		p_wrk = strstr( buf, ref_wrk );
		if( p_wrk != NULL ){
			strncpy( p_saki, p_wrk+len, 1020 );
			p_wrk = strstr( p_saki, "[13][10]" );
			if( p_wrk != NULL && (p_wrk-p_saki) < 1020 )*p_wrk = '\0';
		}
		else{
			*p_saki = '\0';
		}
	}
	
	return(0);
}


/************************************************************************/
/* 		Rg[R[hʂ̕i[??]ƌ`jɒu			*/
/************************************************************************/
int change_cntchr_to_ascstr( char* buf )
{
	char wrk[10];
	char* p_wrk;
	int loop_cnt;
	int len;
	
	for( loop_cnt = 0x01; loop_cnt <= 0x1f; loop_cnt++ ){
		sprintf( wrk, "[%d]", loop_cnt );
		len = strlen(wrk);
		while( ( p_wrk = strchr( buf, (char)loop_cnt )) != NULL ){
			strmov( p_wrk+1, p_wrk+len );
			memcpy( p_wrk, wrk, len );
		}
	}
	
	return(0);
}


/************************************************************************/
/* 		wb_쐬														*/
/************************************************************************/
int make_target_header( char* output, char* sentence, int ret_cd )
{

	if( ret_cd == 204 ){
		/* QOSwb_쐬 */
		strcpy( output, "SHIORI/2.0 204 No Content\r\n\r\n" );
	}
	else if( ret_cd == 311 ){
		/* RPPwb_쐬 */
		strcpy( output, "SHIORI/2.4 311 Not Enough\r\nSentence: " );
		strcat( output, sentence );
		strcat( output, "\r\nCharset: " );
		strcat( output, GStrDicCode ); 
		strcat( output, "\r\n\r\n" );
	}
	else if( ret_cd == 312 ){
		/* RPQwb_쐬 */
		strcpy( output, "SHIORI/2.4 312 Advice\r\nSentence: " );
		strcat( output, sentence );
		strcat( output, "\r\nCharset: " );
		strcat( output, GStrDicCode ); 
		strcat( output, "\r\n\r\n" );
	}
	else{
		/* QOOwb_쐬 */
		if( GSendGhostName[0] == '\0' ){
			/* ʏQOOwb_쐬 */
			strcpy( output, "SHIORI/2.0 200 OK\r\nSentence: " );
			strcat( output, sentence );
			strcat( output, "\r\nCharset: " );
			strcat( output, GStrDicCode ); 
			strcat( output, "\r\n\r\n" );
		}
		else{
			/* AgetQOOwb_쐬 */
			int loop_cnt;
			char wrk[16];
			sprintf( output, "SHIORI/2.3 200 OK\r\nSender: %s\r\nTo: %s\r\nAge: %d\r\nSentence: ", 
								GGhostName, GSendGhostName, GSendAge );
			strcat( output, sentence );
			strcat( output, "\r\nCharset: " );
			strcat( output, GStrDicCode ); 
			for( loop_cnt = 0; loop_cnt < 8; loop_cnt++ ){
				if( GReference[loop_cnt][0] != '\0' ){
					sprintf( wrk, "\r\nReference%d: ", loop_cnt );
					strcat( output, wrk );
					strcat( output, GReference[loop_cnt] );
				}
			}
			strcat( output, "\r\n\r\n" ); 
		}
	}
	
	return(0);
}


/************************************************************************/
/* 		wb_쐬iPpj											*/
/************************************************************************/
int make_target_header_word( char* output, char* word, int ret_cd )
{

	if( ret_cd == 204 ){
		/* QOSwb_쐬 */
		strcpy( output, "SHIORI/2.0 204 No Content\r\n\r\n" );
	}
	else{
		/* QOOwb_쐬 */
		strcpy( output, "SHIORI/2.0 200 OK\r\nWord: " );
		strcat( output, word );
		strcat( output, "\r\nCharset: " );
		strcat( output, GStrDicCode ); 
		strcat( output, "\r\n\r\n" );
	}
	
	return(0);
}


/************************************************************************/
/* 		wb_쐬iSHIORI/3.0pj										*/
/************************************************************************/
int make_target_header30( char* output, char* outbuf, int ret_cd )
{

	if( ret_cd == 204 ){
		/* QOSwb_쐬 */
		strcpy( output, "SHIORI/3.0 204 No Content\r\n\r\n" );
	}
	else if( ret_cd == 311 ){
		/* RPPwb_쐬 */
		strcpy( output, "SHIORI/3.0 311 Not Enough\r\nValue: " );
		strcat( output, outbuf );
		strcat( output, "\r\nCharset: " );
		strcat( output, GStrDicCode ); 
		strcat( output, "\r\n\r\n" );
	}
	else if( ret_cd == 312 ){
		/* RPQwb_쐬 */
		strcpy( output, "SHIORI/3.0 312 Advice\r\nValue: " );
		strcat( output, outbuf );
		strcat( output, "\r\nCharset: " );
		strcat( output, GStrDicCode ); 
		strcat( output, "\r\n\r\n" );
	}
	else{
		/* QOOwb_쐬 */
		strcpy( output, "SHIORI/3.0 200 OK\r\nValue: " );
		strcat( output, outbuf );
		strcat( output, "\r\nCharset: " );
		strcat( output, GStrDicCode ); 
		strcat( output, "\r\n\r\n" );
	}
	
	return(0);
}


